BorderedMorph subclass: #InsideSelectionMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HyperCardNostalgia'!
TextLink subclass: #MiCardLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HyperCardNostalgia'!
BorderedMorph subclass: #MiIndiceVisual
	instanceVariableNames: 'visualNumberOfCards'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HyperCardNostalgia'!
BorderedMorph subclass: #MiStack
	instanceVariableNames: 'htmlDir listaImages index currentCard lastCardNumber visualNumberOfCards'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HyperCardNostalgia'!
BorderedMorph subclass: #MiTarjetaCard
	instanceVariableNames: 'index image hijos font title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HyperCardNostalgia'!

!ServerDirectory commentStamp: '<historical>' prior: 0!
Holds all the information needed to read or write on a directory of an internet server.  I am used for FTP and HTTP (and STMP?  NNTP?).  The password policy is: unless it is a public password (like annomyous), clear all passwords before any snapshot.  There is a way to store passwords on the disk.

server 		'www.disney.com'  or '123.34.56.08' or the ServerDirectory above me 
			(if I am a subdirectory sharing the info in a master directory)
directory 	'ftp/pubs/'  name of my directory within the server or superdirectory.
			(for file://, directory is converted to local delimiters.)
type 		#ftp	what you can do in this directory
user 		'Jones45'
password 	an instance of Password.  
group 		an Association ('group name' -> an array of ServerDirectorys)
			If this first one is down, try the next one.  Store on all of them.  I am in the list.
moniker 	'Main Squeak Directory'  Description of this directory.
altURL		When a FTP server holds some web pages, the altURL of those pages is often
			different from the FTP directory.  Put the altURL here.  If the directory is 
			'public_html/Squeak/', the altURL might be 'www.webPage.com/~kaehler2/
			Squeak/'.
urlObject	An instance of a subclass of Url.  It is very good at parsing complex urls.
			Relative references.  file:// uses this.  Use this in the future instead of 
			server and directory inst vars.
socket		nil or an FTPSocket.  Only non-nil if the connection is being kept open
			for multiple stores or retrievals.  
loaderUrl	a partial url that is ised to invoke squeak in a browser and load a project.

A normal call on some command like (aServer getFileNamed: 'foo') does not set 'socket'.  Socket being nil tells it to close the connection and destroy the socket after this one transcation.  If the caller stores into 'socket', then the same command does NOT close the 
connection.  
	Call 'openKeepFTP' or 'openGroup' to store into socket and keep the connection open.  It is up to the user to call 'quit' or 'closeGroup' later.

DD openKeepFTP.
Transcript cr; show: ((DD getFileNamed: '1198misc-tkKG.cs') next: 100).
Transcript cr; show: ((DD getFileNamed: '1192multFinder-tkKF.cs') next: 100).
DD quit.!
]style[(677 8 1493)f1,f1LPassword Comment;,f1!


!InsideSelectionMorph methodsFor: 'miscellaneous' stamp: 'EDC 10/8/2002 07:02'!
deSelect
	| acambiar |
	acambiar _ submorphs
				collect: [:each | each].
	self delete.
	acambiar do: [:each | each openInWorld].! !

!InsideSelectionMorph methodsFor: 'layout-properties' stamp: 'di 8/31/2000 22:29'!
addHandlesTo: aHaloMorph box: box
	| onlyThese |
	aHaloMorph haloBox: box.
	onlyThese _ #(addDismissHandle: addMenuHandle: addGrabHandle: addDragHandle: addDupHandle: addHelpHandle: addGrowHandle: addFontSizeHandle: addFontStyleHandle: addFontEmphHandle: addRecolorHandle:).
	Preferences haloSpecifications do:
		[:aSpec | (onlyThese includes: aSpec addHandleSelector) ifTrue:
				[aHaloMorph perform: aSpec addHandleSelector with: aSpec]].
	aHaloMorph innerTarget addOptionalHandlesTo: aHaloMorph box: box! !

!InsideSelectionMorph methodsFor: 'layout-properties' stamp: 'di 8/31/2000 22:59'!
addOptionalHandlesTo: aHalo box: box
	aHalo addHandleAt: box leftCenter color: Color blue icon: nil
		on: #mouseUp send: #addOrRemoveItems: to: self.! !

!InsideSelectionMorph methodsFor: 'layout-properties' stamp: 'edc 8/13/2004 06:54'!
addOrRemoveItems: handOrEvent 
	"Make a new selection extending the current one."
	| oldOwner hand |
	hand := (handOrEvent isKindOf: HandMorph)
				ifTrue: [handOrEvent]
				ifFalse: [handOrEvent hand].

	hand
		addMorphBack: ((self class
				newBounds: (hand lastEvent cursorPoint extent: 16 @ 16))
				setOtherSelection: self).
	oldOwner := owner.
	self world abandonAllHalos.
	"Will delete me"
	oldOwner addMorph: self! !

!InsideSelectionMorph methodsFor: 'layout-properties' stamp: 'EDC 10/5/2002 08:15'!
alignBottomEdges
	"Make the bottom coordinate of all my elements be the same"
	| maxBottom |
	maxBottom _ (submorphs
				collect: [:itm | itm bottom]) max.
	submorphs
		do: [:itm | itm bottom: maxBottom].
self newExtent! !

!InsideSelectionMorph methodsFor: 'layout-properties' stamp: 'EDC 10/5/2002 08:15'!
alignCentersHorizontally
	"Make every morph in the selection have the same vertical center as the 
	topmost item."
	| minLeft leftMost |
	submorphs size > 1
		ifFalse: [^ self].
	minLeft _ (submorphs
				collect: [:itm | itm left]) min.
	leftMost _ submorphs
				detect: [:m | m left = minLeft].
	submorphs
		do: [:itm | itm center: itm center x @ leftMost center y].
	self newExtent! !

!InsideSelectionMorph methodsFor: 'layout-properties' stamp: 'EDC 10/5/2002 08:15'!
alignCentersVertically
	"Make every morph in the selection have the same horizontal center as 
	the topmost item."
	| minTop topMost |
	submorphs size > 1
		ifFalse: [^ self].
	minTop _ (submorphs
				collect: [:itm | itm top]) min.
	topMost _ submorphs
				detect: [:m | m top = minTop].
	submorphs
		do: [:itm | itm center: topMost center x @ itm center y].
	self newExtent! !

!InsideSelectionMorph methodsFor: 'layout-properties' stamp: 'EDC 10/5/2002 08:16'!
alignLeftEdges
	"Make the left coordinate of all my elements be the same"
	| minLeft |
	minLeft _ (submorphs
				collect: [:itm | itm left]) min.
	submorphs
		do: [:itm | itm left: minLeft].
	self newExtent! !

!InsideSelectionMorph methodsFor: 'layout-properties' stamp: 'EDC 10/5/2002 08:16'!
alignRightEdges
	"Make the right coordinate of all my elements be the same"
	| maxRight |
	maxRight _ (submorphs
				collect: [:itm | itm right]) max.
	submorphs
		do: [:itm | itm right: maxRight].
	self newExtent! !

!InsideSelectionMorph methodsFor: 'layout-properties' stamp: 'EDC 10/5/2002 08:16'!
alignTopEdges
	"Make the top coordinate of all my elements be the same"
	| minTop |
	minTop _ (submorphs
				collect: [:itm | itm top]) min.
	submorphs
		do: [:itm | itm top: minTop].
	self newExtent! !

!InsideSelectionMorph methodsFor: 'layout-properties' stamp: 'di 8/31/2000 22:59'!
balloonHelpTextForHandle: aHandle
	aHandle eventHandler firstMouseSelector == #addOrRemoveItems:
		ifTrue: [^'Add items to, or remove them from, this selection.'].
	^ super balloonHelpTextForHandle: aHandle! !

!InsideSelectionMorph methodsFor: 'layout-properties' stamp: 'di 9/19/2000 18:25'!
borderColor: aColor

	| bordered |
	bordered _ submorphs select: [:m | m isKindOf: BorderedMorph].
	undoProperties ifNil: [undoProperties _ bordered collect: [:m | m borderColor]].
	bordered do: [:m | m borderColor: aColor]! !

!InsideSelectionMorph methodsFor: 'layout-properties' stamp: 'di 9/19/2000 18:25'!
borderWidth: aWidth

	| bordered |
	bordered _ submorphs select: [:m | m isKindOf: BorderedMorph].
	undoProperties ifNil: [undoProperties _ bordered collect: [:m | m borderWidth]].
	bordered do: [:m | m borderWidth: aWidth]! !

!InsideSelectionMorph methodsFor: 'layout-properties' stamp: 'di 8/23/2000 17:06'!
dismissViaHalo

	super dismissViaHalo.
	submorphs do: [:m | m dismissViaHalo]! !

!InsideSelectionMorph methodsFor: 'layout-properties' stamp: 'nk 3/12/2001 17:08'!
doDup: evt fromHalo: halo handle: dupHandle.

	submorphs _ self duplicateMorphCollection: submorphs.
	submorphs do: [:m | self owner addMorph: m].
	dupDelta == nil
		ifTrue: ["First duplicate operation -- note starting location"
				dupLoc _ self position.
				evt hand grabMorph: self.
				halo removeAllHandlesBut: dupHandle]
		ifFalse: ["Subsequent duplicate does not grab, but only moves me and my morphs"
				dupLoc _ nil.
				self position: self position + dupDelta]
! !

!InsideSelectionMorph methodsFor: 'layout-properties' stamp: 'di 9/19/2000 21:53'!
fillStyle: aColor
	undoProperties ifNil: [undoProperties _ submorphs collect: [:m | m fillStyle]].
	submorphs do: [:m | m fillStyle: aColor]! !

!InsideSelectionMorph methodsFor: 'layout-properties' stamp: 'di 8/31/2000 20:50'!
maybeAddCollapseItemTo: aMenu
	"... don't "! !

!InsideSelectionMorph methodsFor: 'layout-properties' stamp: 'sw 3/6/2002 00:04'!
organizeIntoColumn
	"Place my objects in a column-enforcing container"

	((AlignmentMorph inAColumn: submorphs) setNameTo: 'Column'; color: Color orange muchLighter; enableDragNDrop: true; yourself) openInHand
! !

!InsideSelectionMorph methodsFor: 'layout-properties' stamp: 'sw 3/6/2002 00:04'!
organizeIntoRow
	"Place my objects in a row-enforcing container"

	((AlignmentMorph inARow: submorphs) setNameTo: 'Row'; color: Color orange muchLighter; enableDragNDrop: true; yourself) openInHand
! !

!InsideSelectionMorph methodsFor: 'menu' stamp: 'sw 3/19/2002 22:55'!
addCustomMenuItems: aMenu hand: aHandMorph
	"Add custom menu items to the menu"

	super addCustomMenuItems: aMenu hand: aHandMorph.
	aMenu addLine.
	aMenu add: 'add or remove items' target: self selector: #addOrRemoveItems: argument: aHandMorph.
	aMenu addList: #(
		-
		('place into a row' organizeIntoRow)
		('place into a column' organizeIntoColumn)
		-
		('align left edges' alignLeftEdges)
		('align top edges' alignTopEdges)
		('align right edges' alignRightEdges)
		('align bottom edges' alignBottomEdges)
		-
		('align centers vertically' alignCentersVertically)
		('align centers horizontally' alignCentersHorizontally))


! !

!InsideSelectionMorph methodsFor: 'menu' stamp: 'edc 8/13/2004 06:50'!
addMenuItemsTo: aMenu hand: aHandMorph 
	"Add custom menu items to the menu"
	super addCustomMenuItems: aMenu hand: aHandMorph.
	
aMenu
		add: 'eliminar seleccion '
		target: self
		action: #deSelect.
	aMenu addLine.
	aMenu
		add: 'add or remove items'
		target: self
		selector: #addOrRemoveItems:
		argument: aHandMorph.
	aMenu addList: #(#- #('place into a row' #organizeIntoRow) #('place into a column' #organizeIntoColumn) #- #('align left edges' #alignLeftEdges) #('align top edges' #alignTopEdges) #('align right edges' #alignRightEdges) #('align bottom edges' #alignBottomEdges) #- #('align centers vertically' #alignCentersVertically) #('align centers horizontally' #alignCentersHorizontally) )! !

!InsideSelectionMorph methodsFor: 'event handling' stamp: 'EDC 10/5/2002 07:54'!
handlesMouseDown: evt 
	"Prevent stray clicks from picking up the whole game in MVC."
	^ Smalltalk isMorphic not
		or: [evt yellowButtonPressed]! !

!InsideSelectionMorph methodsFor: 'event handling' stamp: 'EDC 10/5/2002 07:54'!
mouseDown: evt 
	| menu |
	evt yellowButtonPressed
		ifFalse: [^ evt hand waitForClicksOrDrag: self event: evt].
	menu _ MenuMorph new defaultTarget: self.
	self addMenuItemsTo: menu hand: evt hand.
	menu popUpEvent: evt in: self world! !

!InsideSelectionMorph methodsFor: 'event handling' stamp: 'edc 8/13/2004 06:58'!
setOtherSelection: otherOrNil 
	otherSelection := otherOrNil.
	otherOrNil isNil 
		ifTrue: [super borderColor: Color blue]
		ifFalse: 
			[itemsAlreadySelected := otherSelection selectedItems.
			super borderColor: Color green]! !

!InsideSelectionMorph methodsFor: 'initialization' stamp: 'EDC 10/5/2002 07:01'!
initialize
	super initialize.
	color _ Color transparent.
	borderWidth _ 2.
	borderColor _ Color red.! !

!InsideSelectionMorph methodsFor: 'submorphs-add/remove' stamp: 'EDC 10/5/2002 08:15'!
addMorph: aMorph 
	| |
	super addMorph: aMorph.
	
	self newExtent! !

!InsideSelectionMorph methodsFor: 'submorphs-add/remove' stamp: 'EDC 10/30/2002 08:16'!
newExtent
	| minLeft minTop minRight minBottom oldPositions |
	minLeft _ (submorphs
				collect: [:itm | itm left]) min.
	minTop _ (submorphs
				collect: [:itm | itm top]) min.
	minRight _ (submorphs
				collect: [:itm | itm right]) max.
	minBottom _ (submorphs
				collect: [:itm | itm bottom]) max.
oldPositions _ (submorphs
				collect: [:itm | itm position]) .
	self
		bounds: (Rectangle origin: minLeft @ minTop corner: minRight @ minBottom).
	submorphs with: oldPositions do: [:each :oldP | each position: oldP]! !


!MiCardLink methodsFor: 'as yet unclassified' stamp: 'edc 11/18/2004 08:36'!
actOnClickFor: anObject
	"Do what you can with this URL.  Later a web browser."

	| |
(anObject ownerChain ) do: [ :any| (any isKindOf: MiStack) ifTrue: [any goToCardName: self]].! !


!MiIndiceVisual methodsFor: 'initialization' stamp: 'edc 8/12/2004 09:32'!
initialize
	
	|  frame |
	super initialize.
self useRoundedCorners;
				color: (Color
						r: 0.4
						g: 0.4
						b: 0.4
						alpha: 0.5);
				 borderWidth: 2.
	visualNumberOfCards :=  UpdatingStringMorph new.
	
	visualNumberOfCards initWithContents: '1' font:  (StrikeFont familyName:  #ComicSansMS size: 11) emphasis: 1.
		visualNumberOfCards		color: Color red.
				
	self extent: visualNumberOfCards extent + (8 @ 6) asPoint.
	frame := LayoutFrame new.
	frame leftFraction: 0.5 offset: visualNumberOfCards width // -2.
	frame topFraction: 0 offset: 0.
	visualNumberOfCards layoutFrame: frame.
	self layoutPolicy: ProportionalLayout new.
	self addMorph: visualNumberOfCards.
	^ self
	! !

!MiIndiceVisual methodsFor: 'stepping and presenter' stamp: 'edc 8/12/2004 09:00'!
step 
"| old| 
old := visualNumberOfCards text asString asInteger > 1 ifTrue:[ self extent: visualNumberOfCards extent + (8 @ 6) asPoint.
	self owner goToPage: old ]."

! !

!MiIndiceVisual methodsFor: 'change reporting' stamp: 'edc 8/12/2004 08:22'!
handleEvent: anEvent 
anEvent isKeyboard ifTrue: [self halt.
	self literal: submorphs last contents]! !

!MiIndiceVisual methodsFor: 'change reporting' stamp: 'edc 8/10/2004 08:07'!
literal: anObject 
	literal := anObject asInteger.
	self updateLiteralLabel.
	submorphs last informTarget.
	owner checkIndex: self literal.
	! !

!MiIndiceVisual methodsFor: 'accessing' stamp: 'edc 8/12/2004 08:22'!
visualNumberOfCards
	"Answer the value of visualNumberOfCards"

	^ visualNumberOfCards! !

!MiIndiceVisual methodsFor: 'accessing' stamp: 'edc 8/12/2004 08:22'!
visualNumberOfCards: anObject
	"Set the value of visualNumberOfCards"

	visualNumberOfCards _ anObject! !


!MiStack methodsFor: 'initialization' stamp: 'edc 11/14/2004 08:56'!
addCardFromHtmlFile: afileName name: cardName
|  input w  |


	self addCardName: cardName.
	
	input :=  FileStream oldFileNamed: afileName.
	w := (HtmlParser parse: input) formattedText.
	self fieldFillingThisCard:  w ! !

!MiStack methodsFor: 'initialization' stamp: 'edc 12/8/2004 08:55'!
arregla

|   todas|
todas := self allCards.
1 to: todas size do: [ :ind| currentCard _ todas at: ind.
self currentCard submorphs do:[ :each| (each isKindOf: RectangleMorph)  ifTrue: [ each delete]].
currentCard index: ind.
currentCard show.]



! !

!MiStack methodsFor: 'initialization' stamp: 'edc 8/30/2004 08:08'!
buildStackFromHtml
| fileName input w |
fileName _ (htmlDir findTokens: FileDirectory slash) last.
htmlDir _ htmlDir copyReplaceAll: fileName with: ''.
listaImages do: [ :each| fileName _ (each findTokens: FileDirectory slash) last.
	fileName _  fileName copyUpTo: $..
	(FileDirectory default fileExists: htmlDir ,each) ifTrue: [
	self addCardName: fileName.
	
	input _  FileStream oldFileNamed: htmlDir ,each.
	w := (HtmlParser parse: input) formattedText.
	self fieldFillingThisCard:  w]]! !

!MiStack methodsFor: 'initialization' stamp: 'edc 12/7/2004 08:54'!
doButtons
	| labels actions thisButton frame fill |
frame := PasteUpMorph new.
	
	frame width: self width -8.
frame becomeLikeAHolder.
	fill := GradientFillStyle sample.
	frame fillStyle: fill;
		 borderWidth: 2;
		 borderColor: Color black.


labels := #('First' 'Previous' 'Index' 'AddCard' 'RemoveCard' 'SaveStack' 'Next' 'Last').
actions := #(#goToFirstCard #previous #index #addCard #removeCard #localDiskSave #next #goToLastCard ).
labels with: actions do: [ :bNames :bActions| thisButton  :=(SimpleButtonMorph new label: bNames ;
				 target: self;
				 color: Color lightBlue;
				 actionSelector: bActions).
frame addMorphBack: thisButton ].
frame addMorphBack: self visualNumberOfCards.
frame center: self center.
frame bottom: self bottom.
self addMorph: frame

! !

!MiStack methodsFor: 'initialization' stamp: 'edc 11/13/2004 09:17'!
fancyTextFrom: aFile
| strmIn  f t |
self addCard.
strmIn := (self currentCard findA: ScrollableField) getMyText string.
f _ FileStream oldFileNamed: aFile.
t _ Compiler evaluate: ( f contents) .
	strmIn setMyText: t.
! !

!MiStack methodsFor: 'initialization' stamp: 'edc 10/16/2004 08:40'!
hacerBotones
	| f esteBoton howBoton addBoton  grabaBoton |
	f _ Form fromFileNamed: 'Next.jpg'.
	"Leemos el archivo dentro de un Form"
	esteBoton _ IconicButton new.
	"Creamos una instancia de IconicButton"
	esteBoton initialize.
	"La inicializamos"
	esteBoton labelGraphic: f.
	"Hacemos que utilice nuestro grafico"
	esteBoton target: self.
	"Por defecto los mensajes serár enviados a la clase Utilitarios"
	esteBoton actionSelector: #next.
	"Y la acciona a ejecutar es el nombre del boton"
	esteBoton bottom: self bottom - 3.
	esteBoton right: self right - 3.
	self addMorph: esteBoton.
	self visualIndex: self visualNumberOfCards.
	visualIndex right: esteBoton left - 10;
		 bottom: self bottom - 3.
	self addMorph: visualIndex.
	f _ Form fromFileNamed: 'Previous.jpg'.
	"Leemos el archivo dentro de un Form"
	esteBoton _ IconicButton new.
	"Creamos una instancia de IconicButton"
	esteBoton initialize.
	"La inicializamos"
	esteBoton labelGraphic: f.
	"Hacemos que utilice nuestro grafico"
	esteBoton target: self.
	"Por defecto los mensajes serán enviados a la clase"
	esteBoton actionSelector: #previous.
	"Y la acciona a ejecutar es el nombre del boton"
	esteBoton bottom: self bottom - 3.
	esteBoton left: self left + 3.
	self addMorph: esteBoton.
	howBoton _ (SimpleButtonMorph new label: 'Index';
				 target: self;
				 color: Color lightBlue;
				 actionSelector: #nombres) yourself; left: esteBoton right + 10; bottom: self bottom - 3.
	self addMorph: howBoton.
	addBoton _ (SimpleButtonMorph new label: 'Add Card';
				 target: self;
				 color: Color lightGray;
				 actionSelector: #addCard) yourself; left: howBoton right + 10; bottom: self bottom - 3.
	self addMorph: addBoton.
	grabaBoton _ (SimpleButtonMorph new label: 'Save';
				 target: self;
				 actionSelector: #localDiskSave) yourself; left: addBoton right + 10; bottom: self bottom - 3.
	self addMorph: grabaBoton! !

!MiStack methodsFor: 'initialization' stamp: 'edc 12/7/2004 08:38'!
initialize
	
	| |
	super initialize.
	self extent: 512 @ 342;color: Color paleYellow.
	
	index := 1.

lastCardNumber := 0.
	self doButtons.
	self openCenteredInWorld.

	
	self addCard.
	! !

!MiStack methodsFor: 'initialization' stamp: 'edc 12/7/2004 09:03'!
initializeFromHtml
	
	super initialize.
	self extent: 512 @ 342;color: Color paleYellow.
	listaImages := OrderedCollection new.
	index := 1.

lastCardNumber := 0.
	self doButtons.
	self openCenteredInWorld.
	
	! !

!MiStack methodsFor: 'initialization' stamp: 'edc 8/30/2004 08:30'!
moreHtml
| fileName input w strmIn listLink  newLink cleabLink |
strmIn _ (self currentCard findA: ScrollableField) getMyText string.
listLink := Set new.

 '<a href=".*' asRegex matchesIn: strmIn do: [ :each| newLink := (each  findTokens: '"') second. 
	cleabLink _ newLink  copyReplaceAll:'/' with: ':' .
	cleabLink :=  cleabLink copyReplaceAll:'%20' with: ' ' .
	listLink add: cleabLink].

strmIn close.



fileName _ (htmlDir findTokens: FileDirectory slash) last.
htmlDir _ htmlDir copyReplaceAll: fileName with: ''.
listaImages do: [ :each| fileName _ (each findTokens: FileDirectory slash) last.
	fileName _  fileName copyUpTo: $..
	(FileDirectory default fileExists: htmlDir ,each) ifTrue: [
	self addCardName: fileName.
	
	input _  FileStream oldFileNamed: htmlDir ,each.
	w := (HtmlParser parse: input) formattedText.
	self fieldFillingThisCard:  w]]! !

!MiStack methodsFor: 'fileIn/out' stamp: 'edc 3/26/2003 17:44'!
loadHerencia
	| inputStream |
	inputStream _ ReferenceStream fileNamed: 'herencia.obj'.
todasMisVacas _ inputStream next.
	
	inputStream close! !

!MiStack methodsFor: 'fileIn/out' stamp: 'edc 11/14/2004 08:01'!
localDiskSave
| zip baseDir rw |
baseDir := ServerDirectory localSqueakBooksDirectory,FileDirectory slash.
zip := ZipArchive new.
self allCards do: [ :each | rw := RWBinaryOrTextStream on: String new.
	rw fileOutClass: nil andObject: each.
		zip addMember: ((ZipStringMember newFrom: rw contents
						named: each title)
						desiredCompressionMethod: ZipArchive compressionDeflated;
						yourself)
	
	].

zip writeToFileNamed: baseDir, (self getStackNamefromUser) , '.shc'
! !

!MiStack methodsFor: 'events-alarms' stamp: 'edc 8/17/2004 09:11'!
error: aString 
	aString caseOf: {
		['primero'] -> [PopUpMenu inform: 'This is a first card '].
		['fin'] -> [PopUpMenu inform: 'This is a last card '].
['sin'] -> [PopUpMenu inform: 'Esta vaca no tiene hijos ']}
		 otherwise: 
			[Transcript open.
			Transcript show: 'Se pudri¦ todo']! !

!MiStack methodsFor: 'other events' stamp: 'edc 8/17/2004 09:11'!
next

	index = lastCardNumber
		ifTrue: [self error: 'fin']
	ifFalse: [index := index + 1.
			self goToCardIndex: index].! !

!MiStack methodsFor: 'other events' stamp: 'edc 11/21/2004 08:20'!
previous
| result|
	index = 1
		ifTrue: [self error: 'primero']
		ifFalse: [index := index - 1.
			result _ self goToCardIndex: index.
			result ifFalse: [ self previous]].
! !

!MiStack methodsFor: 'accessing' stamp: 'edc 8/8/2004 10:23'!
currentCard
^currentCard! !

!MiStack methodsFor: 'accessing' stamp: 'edc 8/29/2004 17:52'!
currentCard: anObject
	"Set the value of currentCard"

	currentCard _ anObject! !

!MiStack methodsFor: 'accessing' stamp: 'edc 8/8/2004 10:20'!
font
	"Answer the value of font"

	^  StrikeFont familyName: #Accuny15 size: 12.! !

!MiStack methodsFor: 'accessing' stamp: 'edc 8/29/2004 17:52'!
htmlDir
	"Answer the value of htmlDir"

	^ htmlDir! !

!MiStack methodsFor: 'accessing' stamp: 'edc 8/29/2004 17:52'!
htmlDir: anObject
	"Set the value of htmlDir"

	htmlDir _ anObject! !

!MiStack methodsFor: 'accessing' stamp: 'edc 8/29/2004 17:52'!
image
	"Answer the value of image"

	^ image! !

!MiStack methodsFor: 'accessing' stamp: 'edc 8/29/2004 17:52'!
image: anObject
	"Set the value of image"

	image _ anObject! !

!MiStack methodsFor: 'accessing' stamp: 'edc 12/7/2004 08:31'!
index
	"Answer the value of index"

	| menu  res |
	menu := CustomMenu new.
	menu title: 'Select Card title '.
	self allCardsTitles
		do: [:each | 
			menu add: each action: #goToPage:.
			menu addLine].
	 menu startUp.
	res := menu selection.
	res > 0 ifTrue: [self goToPage: res]! !

!MiStack methodsFor: 'accessing' stamp: 'edc 8/29/2004 17:52'!
index: anObject
	"Set the value of index"

	index _ anObject! !

!MiStack methodsFor: 'accessing' stamp: 'edc 8/9/2004 07:55'!
lastCardNumber
^ lastCardNumber! !

!MiStack methodsFor: 'accessing' stamp: 'edc 8/9/2004 07:55'!
lastCardNumber: aNumer
lastCardNumber_ aNumer! !

!MiStack methodsFor: 'accessing' stamp: 'edc 8/29/2004 17:52'!
listaImages
	"Answer the value of listaImages"

	^ listaImages! !

!MiStack methodsFor: 'accessing' stamp: 'edc 8/29/2004 17:52'!
listaImages: anObject
	"Set the value of listaImages"

	listaImages _ anObject! !

!MiStack methodsFor: 'accessing' stamp: 'edc 8/29/2004 17:52'!
visualIndex
	"Answer the value of visualIndex"

	^ visualIndex! !

!MiStack methodsFor: 'accessing' stamp: 'edc 8/29/2004 17:52'!
visualIndex: anObject
	"Set the value of visualIndex"

	visualIndex _ anObject! !

!MiStack methodsFor: 'accessing' stamp: 'edc 8/9/2004 10:13'!
visualNumberOfCards
| rect frame |
rect _ RectangleMorph authoringPrototype useRoundedCorners
				color: (Color
						r: 0.4
						g: 0.4
						b: 0.4
						alpha: 0.5);
				 borderWidth: 2.
	visualNumberOfCards _ TextMorph new contents: lastCardNumber asString;
				 textColor: Color red;
				 fontName: #ComicBold size: 9.
	rect extent: visualNumberOfCards extent + (8 @ 6) asPoint.
	frame _ LayoutFrame new.
	frame leftFraction: 0.5 offset: visualNumberOfCards width // -2.
	frame topFraction: 0 offset: 0.
	visualNumberOfCards layoutFrame: frame.
	rect layoutPolicy: ProportionalLayout new.
	rect addMorph: visualNumberOfCards.
	^ rect
	! !

!MiStack methodsFor: 'accessing' stamp: 'edc 8/29/2004 17:52'!
visualNumberOfCards: anObject
	"Set the value of visualNumberOfCards"

	visualNumberOfCards _ anObject! !

!MiStack methodsFor: 'card in a stack' stamp: 'edc 8/9/2004 09:58'!
actualizeNumberOfCards
| |

visualNumberOfCards := self findA: RectangleMorph 
	! !

!MiStack methodsFor: 'card in a stack' stamp: 'edc 10/1/2004 12:01'!
addCard
self lastCardNumber: self lastCardNumber + 1.
index := lastCardNumber.
	currentCard :=MiTarjetaCard index: self lastCardNumber.
	currentCard center: self center;top: self top +2.
	currentCard getCardNamefromUser.
	self addMorph: currentCard.
	visualNumberOfCards contents:  lastCardNumber asString.
	self fieldFillingThisCard: ''
	
	! !

!MiStack methodsFor: 'card in a stack' stamp: 'edc 11/14/2004 08:22'!
addCardFromDisk: aCard
self lastCardNumber: self lastCardNumber + 1.
index := lastCardNumber.
	currentCard :=aCard index: self lastCardNumber.
	currentCard center: self center;top: self top +2.
	
	self addMorph: currentCard.
	visualNumberOfCards contents:  lastCardNumber asString.
	
	
	! !

!MiStack methodsFor: 'card in a stack' stamp: 'edc 8/29/2004 18:07'!
addCardName: aString
self lastCardNumber: self lastCardNumber + 1.
index := lastCardNumber.
	currentCard :=MiTarjetaCard index: self lastCardNumber name: aString.
	currentCard center: self center;top: self top +2.
	self addMorph: currentCard.
	visualNumberOfCards contents:  lastCardNumber asString.! !

!MiStack methodsFor: 'card in a stack' stamp: 'edc 11/18/2004 07:17'!
addCardNoTitle
self lastCardNumber: self lastCardNumber + 1.
index := lastCardNumber.
	currentCard :=MiTarjetaCard index: self lastCardNumber.
	currentCard center: self center;top: self top +2.
	
	self addMorph: currentCard.
	visualNumberOfCards contents:  lastCardNumber asString.
	
	
	! !

!MiStack methodsFor: 'card in a stack' stamp: 'edc 8/30/2004 06:28'!
fieldFillingThisCard: aText
| sf r |
sf := (ScrollableField new) yourself;
	
		color: (Color
				r: 0.972
				g: 0.972
				b: 0.662).
	r := Rectangle
				left: currentCard left + 5
				right: currentCard right - 5
				top: currentCard top + 20
				bottom: currentCard bottom - 5.
	sf bounds: r.
	
	sf setMyText: aText.
	 currentCard addMorph: sf.
	self addMorph: currentCard.
	currentCard submorphs last comeToFront! !

!MiStack methodsFor: 'card in a stack' stamp: 'edc 11/21/2004 08:58'!
goToCardIndex: aNumber
self allCards do:[ :each| each hide].
currentCard := self allCards detect: [ :any| any index = aNumber] ifNone:[ ^false].
currentCard show.
self index: aNumber.
^ true! !

!MiStack methodsFor: 'card in a stack' stamp: 'edc 11/18/2004 08:18'!
goToCardName: aNumber
self halt.
self allCards do:[ :each| each hide].
currentCard := self allCards detect: [ :any| any index = aNumber].
currentCard show.! !

!MiStack methodsFor: 'card in a stack' stamp: 'edc 11/23/2004 09:08'!
goToFirstCard

currentCard _ self allCards first.
self index: 1.
currentCard show.! !

!MiStack methodsFor: 'card in a stack' stamp: 'edc 12/21/2004 15:54'!
goToLastCard


self goToCardIndex:  self lastCardNumber.! !

!MiStack methodsFor: 'card in a stack' stamp: 'edc 10/12/2004 09:07'!
nombres
	| menu sel res |
	menu _ CustomMenu new.
	menu title: 'Select Card title '.
	self allCardsTitles
		do: [:each | 
			menu add: each action: #goToPage:.
			menu addLine].
	sel _ menu startUp.
	res _ menu selection.
	res > 0 ifTrue: [self goToPage: res]! !

!MiStack methodsFor: 'card in a stack' stamp: 'edc 11/21/2004 08:09'!
removeCard
self currentCard delete.
self lastCardNumber: self lastCardNumber - 1.
index := lastCardNumber.
visualNumberOfCards contents:  lastCardNumber asString.
! !

!MiStack methodsFor: 'card in a stack' stamp: 'edc 11/26/2004 10:54'!
renderCardIndex: aNumber 
	self allCards
		do: [:each | each hide].
	currentCard _ self allCards
				detect: [:any | any index = aNumber]
				ifNone: [^ false].
	
	self index: aNumber.
	^ currentCard ! !

!MiStack methodsFor: 'card controls' stamp: 'edc 7/6/2004 15:02'!
getStackNamefromUser
^FillInTheBlank request: 'Give a name for this Stack '.
! !

!MiStack methodsFor: 'card controls' stamp: 'edc 11/21/2004 08:49'!
goToCardTile: aString

| |


currentCard := self allCards detect: [ :any| any title = aString] ifNone: [
	self error: ' No card have this name '
	].
currentCard show.! !

!MiStack methodsFor: 'card controls' stamp: 'edc 7/14/2004 11:04'!
insertCard
| texto r |
	pages isEmpty 
	ifTrue: [^ self insertPageColored: self color]. 
	self insertPageColored: self color. 
	self getPageNamefromUser.
	
	texto :=  self textContainer.
	r := Rectangle
				left: currentCard left + 5
				right: currentCard right - 5
				top: currentCard top + 20
				bottom: currentCard bottom - 5.
	texto bounds: r.
	self currentCard addMorph: texto! !

!MiStack methodsFor: 'card controls' stamp: 'edc 7/7/2004 07:36'!
sortCardByTitle
|  sortedTitles sortedPages |

sortedTitles := (pages collect: [:pg | self pageTitle: pg ]) asSortedCollection .
sortedCards := OrderedCollection new.
 sortedTitles   do: [ :thispage | sortedCards add: (pages detect:[ :pg| thispage = (self cardTitle: pg) ]) ].
pages := pages species new.
	pages addAll: sortedPages

! !

!MiStack methodsFor: 'evaluating' stamp: 'edc 8/9/2004 10:46'!
allCards
^ self submorphs select:[ :each| each isKindOf: MiTarjetaCard] thenCollect:[ :any| any]! !

!MiStack methodsFor: 'evaluating' stamp: 'edc 8/17/2004 10:06'!
allCardsThumbnails
| esteBoton fondo f |
fondo := PasteUpMorph new.
	fondo becomeLikeAHolder.
 self allCards do: [ :each | each show.f := each imageForm.
	f := f scaledToSize: 60@38.
	esteBoton := IconicButton new.
			esteBoton target: self;
				 actionSelector: #goToCardIndex:;
				
				arguments: (Array
						with: (each index)).
				
			esteBoton
				labelGraphic: f.
				fondo addMorphBack: esteBoton
].
fondo width: 80;openInWorld! !

!MiStack methodsFor: 'evaluating' stamp: 'edc 11/23/2004 09:53'!
allCardsTitles
^( self submorphs select:[ :each| each isKindOf: MiTarjetaCard] thenCollect:[ :any|  any title.
	]) asSortedCollection! !

!MiStack methodsFor: 'evaluating' stamp: 'edc 10/1/2004 09:16'!
promptForName: aFileName
	"If aFileName is not nil, return it. Otherwise, prompt the user and return a full name or nil."
	| fileName result |
	aFileName ifNotNil: [ ^aFileName ].
	Cursor normal showWhile: [
		result := (StandardFileMenu newFileMenu: FileDirectory default withPattern: '*.shc')
			startUpWithCaption: 'Save this stack as...'.
		result ifNil: [ ^nil ].
		fileName := result directory fullNameFor: result name.
	].
	^fileName! !

!MiStack methodsFor: 'message handling' stamp: 'edc 8/17/2004 08:37'!
goToPage: aNumber
| searchTitle |
self allCards do:[ :each| each hide].
searchTitle _ self allCardsTitles at: aNumber.
currentCard := self allCards detect: [ :any| any title = searchTitle].
currentCard show.! !

!MiStack methodsFor: 'as yet unclassified' stamp: 'edc 11/18/2004 06:22'!
addCardFromICabZipFile: aFile
| zip   unzipped w|


zip := ZipArchive new readFrom: aFile.
	unzipped := RWBinaryOrTextStream on: (ByteArray new: ((zip members) second ) uncompressedSize).
	(zip members) second extractTo: unzipped.
 unzipped reset.
self addCardNoTitle.
w := (HtmlParser parse: unzipped contents asString)  formattedText.
	self fieldFillingThisCard:  w
	
	

	
! !

!MiStack methodsFor: 'as yet unclassified' stamp: 'edc 11/21/2004 07:28'!
download
	"start downloading a new page.  The page source is downloaded in a background thread"
	|  newUrl  pages initialPath w nuevo| 
pages := #(409 259 1859 69 3563 243 518 216 780 521 778 243 2269 536 781 1023 779 8 946 520 1758 552 1542 145 1848 380 4 332 784 239 48 516 931 542 81 111 785 518 1105 496 761 524 767 161 1055 542 2088 542 577 291 3740 94 504 216 520 215 525 215 5652 2).
	
self lastCardNumber: 0.
	"get the new url"
	
initialPath := 'http://minnow.cc.gatech.edu/squeak/'.

pages do: [ :p| 
newUrl := (initialPath,p asString) asUrl. 


	" if it fundamentally doesn't fit the pages-and-contents model used internally, spawn off an external viewer for it"
	
	newUrl hasContents ifFalse: [ p activate.  ^true ].

	"fork a Process to do the actual downloading, parsing, and formatting.  It's results will be picked up in #step"


	nuevo := newUrl retrieveContentsForBrowser: self .
		

	

self addCardName: p asString.

	
	w := (HtmlParser parse: nuevo) formattedText.
	self fieldFillingThisCard:  w] ! !

!MiStack methodsFor: 'as yet unclassified' stamp: 'edc 11/26/2004 09:36'!
exporting
	| nombre texto blog story slb |
	slb _ SLBlogStore new.
	self allCards
		do: [:each | 
			nombre _ each title.
			texto _ each text.
			
			blog _ SLBlog name: nombre.
			story _ SLStory parent: blog.
			story title: nombre.
			story text: texto.
			story post.
			story _ SLStory parent: blog].
self halt.
	blog save! !


!MiStack class methodsFor: 'as yet unclassified' stamp: 'edc 8/31/2004 08:42'!
moreLinks: aSet baseDir: htmlDir

|   strmIn  newLink cleabLink newLlistLink |

newLlistLink := Set new.
aSet do: [ :aFile|
	self halt.
strmIn := FileStream oldFileNamed: htmlDir,aFile.

 '<a href.*' asRegex matchesIn: strmIn do: [ :each| newLink := (each  findTokens: '"') second. 
	cleabLink := newLink  copyReplaceAll:'/' with: ':' .
	cleabLink :=  cleabLink copyReplaceAll:'%20' with: ' ' .
	newLlistLink add: cleabLink].strmIn close].

strmIn close.! !

!MiStack class methodsFor: 'as yet unclassified' stamp: 'edc 8/31/2004 08:40'!
newFromHtmlFiles: aFile
|  newStack strmIn listLink newLink cleabLink htmlDir|
htmlDir := (aFile findTokens: FileDirectory slash) last.
htmlDir := aFile copyReplaceAll: htmlDir with: ''.
strmIn := FileStream oldFileNamed: aFile.
listLink := Set new.
listLink add:   (aFile findTokens: FileDirectory slash) last.
 '<a href.*' asRegex matchesIn: strmIn do: [ :each| newLink := (each  findTokens: '"') second. 
	cleabLink := newLink  copyReplaceAll:'/' with: ':' .
	cleabLink :=  cleabLink copyReplaceAll:'%20' with: ' ' .
	listLink add: cleabLink].

strmIn close.

self moreLinks: listLink baseDir: htmlDir .


	newStack := self basicNew initializeFromHtml.
	newStack htmlDir: aFile.
	newStack listaImages: listLink.
	newStack buildStackFromHtml.
	^newStack! !

!MiStack class methodsFor: 'as yet unclassified' stamp: 'edc 12/21/2004 15:23'!
reloadMeFromDisk
| zip  file  newStack unzipped  dir lista sel |

dir :=    
FileDirectory default directoryNamed: (FileDirectory on: (ServerDirectory localSqueakBooksDirectory)) pathName .

lista _ dir fileNamesMatching:  '*.shc'.

sel _ (PopUpMenu
  labelArray: lista
  )
  startUp .

file _ dir pathName , FileDirectory slash , (lista at: sel) .
zip := ZipArchive new readFrom: file.


newStack := self basicNew initializeFromHtml.
newStack lastCardNumber: 0.
 zip members do: [ :card|  
	unzipped := RWBinaryOrTextStream on: (ByteArray new: card uncompressedSize).
	card extractTo: unzipped.
 unzipped reset.
	newStack addCardFromDisk: unzipped fileInObjectAndCode.
	

	]
! !


!MiTarjetaCard methodsFor: 'initialization' stamp: 'edc 8/9/2004 17:47'!
initialize
super initialize.
	self extent: 504 @ 306.
hijos  := OrderedCollection new.


! !

!MiTarjetaCard methodsFor: 'accessing' stamp: 'edc 3/26/2003 11:33'!
agregarHijo: anObject 
	"Set the value of hijos"
	hijos add: anObject! !

!MiTarjetaCard methodsFor: 'accessing' stamp: 'edc 11/18/2004 06:25'!
changeTitle: aString
	"Set the value of title"

	| s |
	title := aString.
s := self submorphs detect: [ :any| any isKindOf:	StringMorph ].
	s contents: aString! !

!MiTarjetaCard methodsFor: 'accessing' stamp: 'edc 8/6/2004 19:26'!
font
	"Answer the value of font"

	^  StrikeFont familyName: #Accuny15 size: 12.! !

!MiTarjetaCard methodsFor: 'accessing' stamp: 'edc 8/6/2004 19:27'!
font: anObject
	"Set the value of font"

	font _ anObject! !

!MiTarjetaCard methodsFor: 'accessing' stamp: 'edc 3/26/2003 11:13'!
hijos
	"Answer the value of hijos"

	^ hijos! !

!MiTarjetaCard methodsFor: 'accessing' stamp: 'edc 8/9/2004 10:57'!
hijos: anObject
	"Set the value of hijos"

	hijos _ anObject! !

!MiTarjetaCard methodsFor: 'accessing' stamp: 'edc 3/26/2003 11:13'!
image
	"Answer the value of image"

	^ image! !

!MiTarjetaCard methodsFor: 'accessing' stamp: 'edc 3/26/2003 11:13'!
image: anObject
	"Set the value of image"

	image _ anObject! !

!MiTarjetaCard methodsFor: 'accessing' stamp: 'edc 11/24/2004 07:01'!
index
	"Answer the value of index"
	| rect text frame |
rect := RectangleMorph authoringPrototype useRoundedCorners
				color: (Color
						r: 0.4
						g: 0.4
						b: 0.4
						alpha: 0.5);
				 borderWidth: 2.
	text := TextMorph new contents: index asString;
				 textColor: Color red;
				 fontName: #ComicBold size: 9.
	rect extent: text extent + (8 @ 6) asPoint.
	frame := LayoutFrame new.
	frame leftFraction: 0.5 offset: text width // -2.
	frame topFraction: 0 offset: 0.
	text layoutFrame: frame.
	rect layoutPolicy: ProportionalLayout new.
	rect addMorph: text.
	
	
	rect bottomRight: self bottomRight - 15@0.
	self addMorph: rect.
	^ index! !

!MiTarjetaCard methodsFor: 'accessing' stamp: 'edc 11/24/2004 07:43'!
index: anObject
	"Set the value of index"

	index := anObject.
	self index! !

!MiTarjetaCard methodsFor: 'accessing' stamp: 'edc 11/13/2004 12:19'!
text
| s rw |
s := 'Text string: '.
s := s ,(self submorphs detect:[ :each| each isKindOf: ScrollableField])
text string.

rw := RWBinaryOrTextStream with: (self submorphs detect:[ :each| each isKindOf: ScrollableField])
text runs.
s := s , rw contents asString.
^ s

! !

!MiTarjetaCard methodsFor: 'accessing' stamp: 'edc 8/9/2004 10:57'!
title
	"Answer the value of title"

	^ title! !

!MiTarjetaCard methodsFor: 'accessing' stamp: 'edc 8/9/2004 10:57'!
title: anObject
	"Set the value of title"

	title _ anObject! !

!MiTarjetaCard methodsFor: 'viewing' stamp: 'edc 8/7/2004 09:51'!
showingListView
	"Answer whether the receiver is currently showing a list view"

	^ self hasProperty: #showingListView! !

!MiTarjetaCard methodsFor: 'miscellaneous' stamp: 'edc 8/18/2004 07:20'!
alignSubmorphs

| container |
container := InsideSelectionMorph new.
self submorphsDo: [ :each| (each isKindOf: String) ifFalse: [ container addMorph: each ]].
container openInWorld! !

!MiTarjetaCard methodsFor: 'miscellaneous' stamp: 'edc 8/7/2004 09:49'!
alwaysShowThumbnail
	^ self hasProperty: #alwaysShowThumbnail! !

!MiTarjetaCard methodsFor: 'dropping/grabbing' stamp: 'edc 8/7/2004 09:55'!
acceptDroppingMorph: dropped event: evt
	"The supplied morph, known to be acceptable to the receiver, is now to be assimilated; the precipitating event is supplied"

	| mm tfm aMorph |
	aMorph := self morphToDropFrom: dropped.
	self isWorldMorph
		ifTrue:["Add the given morph to this world and start stepping it if it wants to be."
				self addMorphFront: aMorph.
				(aMorph fullBounds intersects: self viewBox) ifFalse:
					[Beeper beep.  aMorph position: self bounds center]]
		ifFalse:[super acceptDroppingMorph: aMorph event: evt].

	aMorph submorphsDo: [:m | (m isKindOf: HaloMorph) ifTrue: [m delete]].
	aMorph allMorphsDo:  "Establish any penDown morphs in new world"
		[:m | m player ifNotNil:
			[m player getPenDown ifTrue:
				[((mm := m player costume) notNil and: [(tfm := mm owner transformFrom: self) notNil])
					ifTrue: [self noteNewLocation: (tfm localPointToGlobal: mm referencePosition)
									forPlayer: m player]]]].

	self isPartsBin
		ifTrue:
			[aMorph isPartsDonor: true.
			aMorph stopSteppingSelfAndSubmorphs.
			aMorph suspendEventHandler]
		ifFalse:
			[self world startSteppingSubmorphsOf: aMorph].

	self presenter morph: aMorph droppedIntoPasteUpMorph: self.

	self showingListView ifTrue:
		[self sortSubmorphsBy: (self valueOfProperty: #sortOrder).
		self currentWorld abandonAllHalos]! !

!MiTarjetaCard methodsFor: 'dropping/grabbing' stamp: 'sw 2/4/2001 00:54'!
dropEnabled
	"Get this morph's ability to add and remove morphs via drag-n-drop."

	^ (self valueOfProperty: #dropEnabled) ~~ false
! !

!MiTarjetaCard methodsFor: 'dropping/grabbing' stamp: 'sw 9/1/2000 05:37'!
justDroppedInto: aMorph event: anEvent
	"This message is sent to a dropped morph after it has been dropped on--and been accepted by--a drop-sensitive morph"

	super justDroppedInto: aMorph event: anEvent.
	self isPartsBin ifTrue: [self setPartsBinStatusTo: true]  "gets some things right about the subtle case of dropping a parts bin"
! !

!MiTarjetaCard methodsFor: 'dropping/grabbing' stamp: 'gm 2/22/2003 13:08'!
morphToDropFrom: aMorph 
	"Given a morph being carried by the hand, which the hand is about to drop, answer the actual morph to be deposited.  Normally this would be just the morph itself, but several unusual cases arise, which this method is designed to service."

	| aNail representee handy posBlock tempPos |
	handy := self primaryHand.
	posBlock := 
			[:z | 
			tempPos := handy position 
						- ((handy targetOffset - aMorph formerPosition) 
								* (z extent / aMorph extent)) rounded.
			self pointFromWorld: tempPos].
	self alwaysShowThumbnail 
		ifTrue: 
			[aNail := aMorph 
						representativeNoTallerThan: self maxHeightToAvoidThumbnailing
						norWiderThan: self maximumThumbnailWidth
						thumbnailHeight: self heightForThumbnails.
			aNail == aMorph 
				ifFalse: 
					[aMorph formerPosition: aMorph position.
					aNail position: (posBlock value: aNail)].
			^aNail].
	((aMorph isKindOf: MorphThumbnail) 
		and: [(representee := aMorph morphRepresented) owner isNil]) 
			ifTrue: 
				[representee position: (posBlock value: representee).
				^representee].
	self showingListView 
		ifTrue: 
			[^aMorph 
				listViewLineForFieldList: (self valueOfProperty: #fieldListSelectors)].
	(aMorph hasProperty: #newPermanentScript) 
		ifTrue: [^aMorph asEmptyPermanentScriptor].
	((aMorph isKindOf: PhraseTileMorph) or: [aMorph isSyntaxMorph]) 
		ifFalse: [^aMorph].
	aMorph userScriptSelector isEmptyOrNil 
		ifTrue: 
			["non-user"

			self automaticPhraseExpansion ifFalse: [^aMorph]].
	^aMorph morphToDropInPasteUp: self! !

!MiTarjetaCard methodsFor: 'dropping/grabbing' stamp: 'sw 5/2/1998 11:31'!
positionNear: aPoint forExtent: anExtent adjustmentSuggestion: adjustmentPoint
	"Compute a plausible positioning for adding a subpart of size anExtent, somewhere near aPoint, using adjustmentPoint as the unit of adjustment"

	| adjustedPosition |
	adjustedPosition _ aPoint.
	[((self morphsAt: (adjustedPosition + (anExtent // 2))) size > 1) and:  "that 1 is self here"
		[bounds containsPoint: adjustedPosition]]
	whileTrue:
		[adjustedPosition _ adjustedPosition + adjustmentPoint].

	^ adjustedPosition! !

!MiTarjetaCard methodsFor: 'dropping/grabbing' stamp: 'ar 10/11/2000 18:22'!
repelsMorph: aMorph event: ev
	(aMorph wantsToBeDroppedInto: self) ifFalse: [^ false].
	self dropEnabled ifFalse: [^ true].
	(self wantsDroppedMorph: aMorph event: ev) ifFalse: [^ true].
	^ super repelsMorph: aMorph event: ev "consults #repelling flag"! !

!MiTarjetaCard methodsFor: 'dropping/grabbing' stamp: 'ar 10/11/2000 18:22'!
wantsDroppedMorph: aMorph event: evt
	self isWorldMorph ifTrue:[^true]. "always"
	self visible ifFalse: [^ false].  "will be a call to #hidden again very soon"
	self dropEnabled ifFalse: [^ false].
	^ true! !

!MiTarjetaCard methodsFor: 'event handling' stamp: 'mir 1/10/2002 17:35'!
dropFiles: anEvent
	"Handle a number of dropped files from the OS.
	TODO:
		- use a more general mechanism for figuring out what to do with the file (perhaps even offering a choice from a menu)
		- remember the resource location or (when in browser) even the actual file handle
	"
	| numFiles stream handler |
	numFiles _ anEvent contents.
	1 to: numFiles do: [:i |
		stream _ FileStream requestDropStream: i.
		handler _ ExternalDropHandler lookupExternalDropHandler: stream.
		[handler ifNotNil: [handler handle: stream in: self dropEvent: anEvent]]
			ensure: [stream close]].! !

!MiTarjetaCard methodsFor: 'event handling' stamp: 'ar 10/10/2000 15:22'!
handlesKeyboard: evt
	^self isWorldMorph or:[evt keyCharacter == Character tab and:[self hasProperty: #tabAmongFields]]! !

!MiTarjetaCard methodsFor: 'event handling' stamp: 'ar 10/3/2000 22:46'!
handlesMouseDown: evt
	^true! !

!MiTarjetaCard methodsFor: 'event handling' stamp: 'ar 10/10/2000 14:12'!
keyStroke: anEvent
	"A keystroke has been made.  Service event handlers and, if it's a keystroke presented to the world, dispatch it to #unfocusedKeystroke:"

	super keyStroke: anEvent.  "Give event handlers a chance"
	(anEvent keyCharacter == Character tab) ifTrue:
		[(self hasProperty: #tabAmongFields)
			ifTrue:[^ self tabHitWithEvent: anEvent]].
	self isWorldMorph ifTrue:
		[self keystrokeInWorld: anEvent]! !

!MiTarjetaCard methodsFor: 'event handling' stamp: 'ar 2/23/2001 16:44'!
morphToGrab: event
	"Return the morph to grab from a mouse down event. If none, return nil."
	self submorphsDo:[:m|
		((m rejectsEvent: event) not and:[m fullContainsPoint: event cursorPoint]) ifTrue:[^m].
	].
	^nil! !

!MiTarjetaCard methodsFor: 'event handling' stamp: 'jcg 9/21/2001 13:22'!
mouseDown: evt
	"Handle a mouse down event."
	| grabbedMorph handHadHalos |
	grabbedMorph _ self morphToGrab: evt.
	grabbedMorph ifNotNil:[
		grabbedMorph isSticky ifTrue:[^self].
		self isPartsBin ifFalse:[^evt hand grabMorph: grabbedMorph].
		grabbedMorph _ grabbedMorph partRepresented duplicate.
		grabbedMorph restoreSuspendedEventHandler.
		(grabbedMorph fullBounds containsPoint: evt position) 
			ifFalse:[grabbedMorph position: evt position].
		"Note: grabbedMorph is ownerless after duplicate so use #grabMorph:from: instead"
		^evt hand grabMorph: grabbedMorph from: self].

	(super handlesMouseDown: evt)
		ifTrue:[^super mouseDown: evt].
	handHadHalos _ evt hand halo notNil.
	evt hand halo: nil. "shake off halos"
	evt hand releaseKeyboardFocus. "shake of keyboard foci"
	evt shiftPressed ifTrue:[
		^evt hand 
			waitForClicksOrDrag: self 
			event: evt 
			selectors: { #findWindow:. nil. nil. #dragThroughOnDesktop:}
			threshold: 5].
	self isWorldMorph ifTrue: [
		handHadHalos ifTrue: [^self addAlarm: #invokeWorldMenu: with: evt after: 200].
		^self invokeWorldMenu: evt
	].
	"otherwise, explicitly ignore the event if we're not the world,
	so that we could be picked up if need be"
	self isWorldMorph ifFalse:[evt wasHandled: false].
! !

!MiTarjetaCard methodsFor: 'event handling' stamp: 'ar 10/6/2000 00:04'!
mouseUp: evt
	self isWorldMorph ifTrue:[self removeAlarm: #invokeWorldMenu:].
	super mouseUp: evt.! !

!MiTarjetaCard methodsFor: 'event handling' stamp: 'ar 1/10/2001 21:29'!
wantsDropFiles: anEvent
	^self isWorldMorph! !

!MiTarjetaCard methodsFor: 'event handling' stamp: 'sw 5/6/1998 17:07'!
wantsKeyboardFocusFor: aSubmorph
	aSubmorph inPartsBin ifTrue: [^ false].
	aSubmorph wouldAcceptKeyboardFocus ifTrue: [ ^ true].
	^ super wantsKeyboardFocusFor: aSubmorph! !

!MiTarjetaCard methodsFor: 'as yet unclassified' stamp: 'edc 8/18/2004 07:32'!
getCardNamefromUser
|  pn aString |

pn := FillInTheBlank request: 'Name of this card ? '.
aString := StringMorph contents: pn font: self font.
self title: pn.
aString emphasis: 1.
aString center: (self  center x) @ (self top + 10).
aString color: Color yellow.
self  addMorph: aString.
aString beSticky.
aString setProperty: #couldBeAligned toValue: false.
 
! !


!MiTarjetaCard class methodsFor: 'as yet unclassified' stamp: 'edc 8/9/2004 08:33'!
index: aNumber
^(self new) index: aNumber! !

!MiTarjetaCard class methodsFor: 'as yet unclassified' stamp: 'edc 8/29/2004 19:24'!
index: aNumber name: aString
| card titMorph |
card _ (self new) index: aNumber.

card title: aString. 
titMorph _ (StringMorph contents: aString font: card font).
titMorph emphasis: 1.
card addMorph: titMorph.
titMorph center: (card  center x) @ (card top + 10).
titMorph color: Color yellow. 
titMorph beSticky.
titMorph setProperty: #couldBeAligned toValue: false.
^ card! !


!ServerDirectory methodsFor: 'accessing' stamp: 'mir 6/25/2001 12:43'!
acceptsUploads: aBoolean
	"Do nothing yet"! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 1/14/1999 21:01'!
altUrl
	"When a ftp server also has http access, use this to store the http url"
	^ altURL! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 1/14/1999 20:56'!
altUrl: aString
	altURL _ aString! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 9/18/1998 23:24'!
bareDirectory

	^ directory first == $/ 
		ifTrue: [directory copyFrom: 2 to: directory size]
		ifFalse: [directory]! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 9/19/1998 18:54'!
copy

	| new |
	new _ self clone.
	new urlObject: urlObject copy.
	^ new! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 11/24/1998 15:00'!
directory
	"String of part of url that is the directory. Has slashes as separators"

	urlObject ifNotNil: [^ urlObject pathDirString].
	^ directory! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 1/3/98 21:36'!
directory: anObject
	directory _ anObject! !

!ServerDirectory methodsFor: 'accessing' stamp: 'RAA 10/17/2000 14:57'!
directoryObject

	^self! !

!ServerDirectory methodsFor: 'accessing' stamp: 'mir 6/25/2001 10:45'!
downloadUrl
	"The url under which files will be accessible."
	^(self altUrl
		ifNil: [self realUrl]
		ifNotNil: [self altUrl]) , '/'! !

!ServerDirectory methodsFor: 'accessing' stamp: 'RAA 9/14/2000 13:26'!
fullPath: serverAndDirectory
	"Parse and save a full path.  Convention:  if ftp://user@server/dir, then dir is relative to user's directory.  dir has no slash at beginning.  If ftp://server/dir, then dir is absolute to top of machine, give dir a slash at the beginning."

	| start bare sz userAndServer both slash score match best sd |
	bare _ serverAndDirectory.
	sz _ serverAndDirectory size.
	bare size > 0 ifTrue: [ 
		start _ (bare copyFrom: 1 to: (8 min: sz)) asLowercase.
		((start beginsWith: 'ftp:') or: [start beginsWith: 'nil:']) "fix bad urls"
			ifTrue: [type _ #ftp.
				bare _ bare copyFrom: (7 min: sz) to: bare size].
		(start beginsWith: 'http:') 
			ifTrue: [type _ #http.
				bare _ bare copyFrom: (8 min: sz) to: serverAndDirectory size].
		((start beginsWith: 'file:') or: [type == #file])
			ifTrue: [type _ #file.
				urlObject _ FileUrl absoluteFromText: serverAndDirectory.
				^ self]].
	userAndServer _ bare copyUpTo: self pathNameDelimiter.
	both _ userAndServer findTokens: '@'.
	slash _ both size.	"absolute = 1, relative = 2"
	server _ both last.
	both size > 1 ifTrue: [user _ both at: 1].
	bare size > (userAndServer size + 1) 
		ifTrue: [directory _ bare copyFrom: userAndServer size + slash to: bare size]
		ifFalse: [directory _ ''].

	"If this server is already known, copy in its userName and password"
	type == #ftp ifFalse: [^ self].
	score _ -1.
	ServerDirectory serverNames do: [:name |
		sd _ ServerDirectory serverNamed: name.
		server = sd server ifTrue: [
			match _ directory asLowercase charactersExactlyMatching: sd directory asLowercase.
			match > score ifTrue: [score _ match.  best _ sd]]].
	best ifNil: [
		self fromUser
	] ifNotNil: [
		user _ best user.
		altURL _ best altUrl.
		loaderUrl _ best loaderUrl.
		self password: best password
	].
! !

!ServerDirectory methodsFor: 'accessing' stamp: 'RAA 6/23/2000 09:40'!
isTypeFTP

	^self typeWithDefault == #ftp! !

!ServerDirectory methodsFor: 'accessing' stamp: 'RAA 6/23/2000 09:41'!
isTypeFile

	^self typeWithDefault == #file! !

!ServerDirectory methodsFor: 'accessing' stamp: 'RAA 6/23/2000 09:46'!
isTypeHTTP

	^self typeWithDefault == #http! !

!ServerDirectory methodsFor: 'accessing' stamp: 'mir 12/8/2003 14:18'!
keepAlive: aBoolean
	keepAlive := aBoolean! !

!ServerDirectory methodsFor: 'accessing' stamp: 'RAA 9/14/2000 13:22'!
loaderUrl

	^loaderUrl! !

!ServerDirectory methodsFor: 'accessing' stamp: 'RAA 9/14/2000 13:24'!
loaderUrl: aString

	loaderUrl _ aString! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 12/14/1998 19:45'!
moniker
	"a plain language name for this directory"

	moniker ifNotNil: [^ moniker].
	directory ifNotNil: [^ self server].
	urlObject ifNotNil: [^ urlObject toText].
	^ ''! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 5/20/1998 12:26'!
moniker: nickName
	"a plain language name for this directory"

	moniker _ nickName! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 2/14/1999 20:44'!
password

	passwordHolder ifNil: [passwordHolder _ Password new].
	^ passwordHolder passwordFor: self	"may ask the user"! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 1/5/98 21:55'!
password: pp

	passwordHolder _ Password new.
	pp class == String 
		ifTrue: [passwordHolder cache: pp. ^ self].
	pp isInteger 
		ifTrue: [passwordHolder sequence: pp]
		ifFalse: [passwordHolder _ pp].! !

!ServerDirectory methodsFor: 'accessing' stamp: 'mir 6/29/2001 01:04'!
passwordSequence

	^passwordHolder
		ifNotNil: [passwordHolder sequence]! !

!ServerDirectory methodsFor: 'accessing' stamp: 'mir 6/29/2001 01:16'!
passwordSequence: aNumber

	passwordHolder ifNil: [passwordHolder _ Password new].
	passwordHolder sequence: aNumber! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 5/23/1998 09:41'!
printOn: aStrm
	aStrm nextPutAll: self class name; nextPut: $<.
	aStrm nextPutAll: self moniker.
	aStrm nextPut: $>.
! !

!ServerDirectory methodsFor: 'accessing' stamp: 'RAA 6/23/2000 09:44'!
realUrl
	"a fully expanded version of the url we represent.  Prefix the path with http: or ftp: or file:"

	self isTypeFile ifTrue: [
		self fileNameRelativeTo: self.
		^ urlObject toText
	].
	^ self typeWithDefault asString, '://', self pathName
	! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 11/24/1998 18:18'!
server
	^ server! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 1/3/98 21:36'!
server: anObject
	server _ anObject! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 9/18/1998 23:22'!
slashDirectory

	^ directory first == $/ 
		ifTrue: [directory]
		ifFalse: ['/', directory]! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 2/14/1999 21:44'!
type: aSymbol
	type _ aSymbol! !

!ServerDirectory methodsFor: 'accessing' stamp: 'mir 6/25/2001 17:16'!
typeForPrefs

	^self typeWithDefault! !

!ServerDirectory methodsFor: 'accessing' stamp: 'RAA 6/23/2000 09:30'!
typeWithDefault

	^ type ifNil: [type _ #ftp]! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 1/25/1999 15:12'!
url
	"This was mis-named at the beginning.  Eventually convert over to altUrl and use this for the real url."
	^ self realUrl! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 9/5/1998 17:20'!
url: aString
	altURL _ aString! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 9/6/1998 00:44'!
urlObject
	^ urlObject! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 9/8/1998 11:56'!
urlObject: aUrl

	urlObject _ aUrl! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 11/24/1998 22:16'!
user
	^ user! !

!ServerDirectory methodsFor: 'accessing' stamp: 'tk 1/3/98 21:36'!
user: anObject
	user _ anObject! !

!ServerDirectory methodsFor: 'testing' stamp: 'mir 6/25/2001 12:52'!
acceptsUploads
	^true! !

!ServerDirectory methodsFor: 'testing' stamp: 'mir 4/16/2001 17:41'!
isProjectSwiki
	^false! !

!ServerDirectory methodsFor: 'testing' stamp: 'dgd 12/27/2003 10:47'!
isRemoteDirectory
	"answer whatever the receiver is a remote directory"
	^ true! !

!ServerDirectory methodsFor: 'testing' stamp: 'hg 9/29/2001 15:58'!
isRoot
	^directory = (String with: self pathNameDelimiter)! !

!ServerDirectory methodsFor: 'testing' stamp: 'mir 11/14/2001 16:25'!
isSearchable
	^false! !

!ServerDirectory methodsFor: 'testing' stamp: 'mir 12/8/2003 12:28'!
keepAlive
	keepAlive ifNil: [keepAlive := false].
	^keepAlive! !

!ServerDirectory methodsFor: 'up/download' stamp: 'hg 2/5/2002 16:50'!
fileExists: fileName
	"Does the file exist on this server directory?  fileName must be simple with no / or references to other directories."

	| stream |
	self isTypeFile ifTrue: [^ self fileNames includes: fileName].
	self isTypeHTTP ifTrue: [
		stream _ self readOnlyFileNamed: fileName.
		^stream contents notEmpty].
	"ftp"
	^ self entries anySatisfy: [:entry | entry name = fileName]! !

!ServerDirectory methodsFor: 'up/download' stamp: 'mir 12/8/2003 14:17'!
getDirectory
	"Return a stream with a listing of the current server directory.  (Later -- Use a proxy server if one has been registered.)"

	| listing |
	client := self openFTPClient.
	[listing := client getDirectory]
		ensure: [self quit].
	^ReadStream on: listing! !

!ServerDirectory methodsFor: 'up/download' stamp: 'mir 12/8/2003 14:16'!
getFileList
	"Return a stream with a list of files in the current server directory.  (Later -- Use a proxy server if one has been registered.)"

	| listing |
	client := self openFTPClient.
	[listing := client getFileList]
		ensure: [self quit].
	^ReadStream on: listing! !

!ServerDirectory methodsFor: 'up/download' stamp: 'mir 12/8/2003 14:17'!
getFileNamed: fileNameOnServer
	"Just FTP a file from a server.  Return contents.
	(Later -- Use a proxy server if one has been registered.)"

	| result |
	client := self openFTPClient.
	[result := client getFileNamed: fileNameOnServer]
		ensure: [self quit].
	^result! !

!ServerDirectory methodsFor: 'up/download' stamp: 'hg 2/12/2002 11:44'!
getFileNamed: fileNameOnServer into: dataStream
	
	^self getFileNamed: fileNameOnServer into: dataStream 
		httpRequest: 'Pragma: no-cache', String crlf! !

!ServerDirectory methodsFor: 'up/download' stamp: 'mir 12/8/2003 14:17'!
getFileNamed: fileNameOnServer into: dataStream httpRequest: requestString
	"Just FTP a file from a server.  Return a stream.  (Later -- Use a proxy server if one has been registered.)"

	| resp |
	self isTypeFile ifTrue: [
		dataStream nextPutAll: 
			(resp _ FileStream oldFileNamed: server,(self serverDelimiter asString), 
				self bareDirectory, (self serverDelimiter asString),
				fileNameOnServer) contentsOfEntireFile.
		dataStream dataIsValid.
		^ resp].
	self isTypeHTTP ifTrue: [
		resp _ HTTPSocket httpGet: (self fullNameFor: fileNameOnServer) 
				args: nil accept: 'application/octet-stream' request: requestString.
		resp class == String ifTrue: [^ dataStream].	"error, no data"
		dataStream copyFrom: resp.
		dataStream dataIsValid.
		^ dataStream].

	client _ self openFTPClient.	"Open passive.  Do everything up to RETR or STOR"
	[client getFileNamed: fileNameOnServer into: dataStream]
		ensure: [self quit].

	dataStream dataIsValid.
! !

!ServerDirectory methodsFor: 'up/download' stamp: 'mir 12/8/2003 14:17'!
getOnlyBuffer: buffer from: fileNameOnServer
	"Open ftp, fill the buffer, and close the connection.  Only first part of a very long file."

	| dataStream |
	client := self openFTPClient.
	dataStream := WriteStream on: buffer.
	[client getPartial: buffer size fileNamed: fileNameOnServer into: dataStream]
		ensure: [self quit].
	^buffer! !

!ServerDirectory methodsFor: 'up/download' stamp: 'mir 12/8/2003 16:39'!
putFile: fileStream named: fileNameOnServer
	"Just FTP a local fileStream to the server.  (Later -- Use a proxy server if one has been registered.)"

	client := self openFTPClient.
	client binary.
	[client putFileStreamContents: fileStream as: fileNameOnServer]
		ensure: [self quit]! !

!ServerDirectory methodsFor: 'up/download' stamp: 'RAA 6/23/2000 09:43'!
putFile: fileStream named: fileNameOnServer retry: aBool
	"ar 11/24/1998 Do the usual putFile:named: operation but retry if some error occurs and aBool is set. Added due to having severe transmission problems on shell.webpage.com."
	| resp |
	self isTypeFile ifTrue: [
		^ (FileDirectory on: urlObject pathForDirectory)
			putFile: fileStream named: fileNameOnServer].

	[[resp _ self putFile: fileStream named: fileNameOnServer] 
		ifError:[:err :rcvr| resp _ '5xx ',err]. "Report as error"
	aBool and:[((resp isKindOf: String) and: [resp size > 0]) and:[resp first ~= $2]]] whileTrue:[
		(self confirm:('Error storing ',fileNameOnServer,' on the server.\(',resp,',)\Retry operation?') withCRs) ifFalse:[^resp].
	].
	^resp! !

!ServerDirectory methodsFor: 'up/download' stamp: 'di 3/14/2001 15:34'!
putFileSavingOldVersion: fileStream named: fileNameOnServer

	| tempName oldName |
	"Put a copy of this file out after saving the prior version.
	Nothing happens to the old version until the new vers is successfully stored."
 	tempName _ fileNameOnServer , '.beingWritten'.
	oldName _ fileNameOnServer , '.prior'.
	self putFile: fileStream named: tempName retry: true.
	(self includesKey: oldName) ifTrue: [self deleteFileNamed: oldName].
	self rename: fileNameOnServer toBe: oldName.
	self rename: tempName toBe: fileNameOnServer.
! !

!ServerDirectory methodsFor: 'dis/connect' stamp: 'mir 12/8/2003 15:09'!
openFTPClient

	| loginSuccessful what |
	client
		ifNotNil: [client isConnected
			ifTrue: [^client]
			ifFalse: [client := nil]].
	client _ FTPClient openOnHostNamed: server.
	loginSuccessful := false.
	[loginSuccessful]
		whileFalse: [
			[loginSuccessful := true.
			client loginUser: self user password: self password]
				on: LoginFailedException
				do: [:ex | 
					passwordHolder _ nil.
					what _ (PopUpMenu labels: 'enter password\give up' withCRs) 
						startUpWithCaption: 'Would you like to try another password?'.
					what = 1 ifFalse: [self error: 'Login failed.'. ^nil].
					loginSuccessful := false]].
	client changeDirectoryTo: directory.
	^client! !

!ServerDirectory methodsFor: 'dis/connect' stamp: 'mir 12/8/2003 12:53'!
quit
	"break the connection"

	self keepAlive
		ifFalse: [self quitClient]! !

!ServerDirectory methodsFor: 'dis/connect' stamp: 'mir 12/8/2003 12:53'!
quitClient
	"break the connection"

	client ifNotNil: [client quit].
	client := nil! !

!ServerDirectory methodsFor: 'file directory' stamp: 'RAA 7/4/2000 10:08'!
asServerFileNamed: aName

	| rFile |
	rFile _ self as: ServerFile.
	(aName includes: self pathNameDelimiter)
		ifTrue: [rFile fullPath: aName]
			"sets server, directory(path), fileName.  If relative, merge with self."
		ifFalse: [rFile fileName: aName].	"JUST a single NAME, already have the rest"
			"Mac files that include / in name, must encode it as %2F "
	^rFile
! !

!ServerDirectory methodsFor: 'file directory' stamp: 'tpr 4/28/2004 17:32'!
assureExistence
	"Make sure the current directory exists. If necessary, create all parts inbetween"
	
	self exists ifFalse: [
		self isRoot ifFalse: [
			self containingDirectory assureExistenceOfPath: self localName]]! !

!ServerDirectory methodsFor: 'file directory' stamp: 'tpr 4/28/2004 17:31'!
assureExistenceOfPath: localPath
	"Make sure the local directory exists. If necessary, create all parts inbetween"

	localPath = (String with: self pathNameDelimiter) ifTrue: [^self].
	self assureExistence.
	(self localPathExists: localPath) ifFalse: [
		self createDirectory: localPath].! !

!ServerDirectory methodsFor: 'file directory' stamp: 'hg 9/29/2001 15:23'!
containingDirectory

	self splitName: directory to: [:parentPath :localName |
		^self copy directory: parentPath]! !

!ServerDirectory methodsFor: 'file directory' stamp: 'mir 12/8/2003 14:16'!
createDirectory: localName
	"Create a new sub directory within the current one"

	self isTypeFile ifTrue: [
		^FileDirectory createDirectory: localName
	].

	client := self openFTPClient.
	[client makeDirectory: localName]
		ensure: [self quit].
! !

!ServerDirectory methodsFor: 'file directory' stamp: 'mir 12/8/2003 14:17'!
deleteDirectory: localName
	"Delete the sub directory within the current one.  Call needs to ask user to confirm."

	self isTypeFile ifTrue: [
		^FileDirectory deleteFileNamed: localName
	].
		"Is this the right command???"

	client := self openFTPClient.
	[client deleteDirectory: localName]
		ensure: [self quit].
! !

!ServerDirectory methodsFor: 'file directory' stamp: 'mir 12/8/2003 14:17'!
deleteFileNamed: fullName
	"Detete a remote file.  fullName is directory path, and does include name of the server.  Or it can just be a fileName."
	| file |
	file _ self asServerFileNamed: fullName.
	file isTypeFile ifTrue: [
		^ (FileDirectory forFileName: (file fileNameRelativeTo: self)) 
			deleteFileNamed: file fileName
	].
	
	client := self openFTPClient.
	[client deleteFileNamed: fullName]
		ensure: [self quit].
! !

!ServerDirectory methodsFor: 'file directory' stamp: 'hg 2/8/2002 17:44'!
directoryNamed: localFileName 
	"Return a copy of me pointing at this directory below me"
	| new newPath newAltUrl |
	new _ self copy.
	urlObject
		ifNotNil: [new urlObject path: new urlObject path copy.
			new urlObject path removeLast; addLast: localFileName; addLast: ''.
			^ new].
	"sbw.  When working from an FTP server, the first time we access
	a subdirectory the <directory> variable is empty.  In that case we
	cannot begin with a leading path delimiter since that leads us to
	the wrong place."
	newPath _ directory isEmpty
				ifTrue: [localFileName]
				ifFalse: [directory , self pathNameDelimiter asString , localFileName].
	self altUrl ifNotNil: [
		newAltUrl _ self altUrl, self pathNameDelimiter asString , localFileName].
	new directory: newPath; altUrl: newAltUrl.
	^ new! !

!ServerDirectory methodsFor: 'file directory' stamp: 'tk 2/22/2000 19:51'!
directoryNames
	"Return a collection of names for the subdirectories of this directory."
	"(ServerDirectory serverNamed: 'UIUCArchive') directoryNames"

	^ (self entries select: [:entry | entry at: 4])
		collect: [:entry | entry first]
! !

!ServerDirectory methodsFor: 'file directory' stamp: 'mir 5/13/2003 10:44'!
entries 
	"Return a collection of directory entries for the files and directories in this directory. Each entry is a five-element array: (<name> <creationTime> <modificationTime> <dirFlag> <fileSize>)."
	| dir ftpEntries |
	"We start with ftp directory entries of the form...
d---------   1 owner    group               0 Apr 27 22:01 blasttest
----------   1 owner    group           93812 Jul 21  1997 COMMAND.COM
    1        2   3           4                 5    6  7    8       9   -- token index"
	self isTypeFile ifTrue: [
		urlObject isAbsolute ifFalse: [urlObject default].
		^ (FileDirectory on: urlObject pathForDirectory) entries
	].

	dir _ self getDirectory.
	(dir respondsTo: #contentsOfEntireFile) ifFalse: [^ #()].
	ftpEntries _ dir contentsOfEntireFile findTokens: String crlf.
"ftpEntries inspect."
	^ ftpEntries 
		collect:[:ftpEntry | self class parseFTPEntry: ftpEntry]
		thenSelect: [:entry | entry notNil]! !

!ServerDirectory methodsFor: 'file directory' stamp: 'mir 12/8/2003 14:17'!
exists
	"It is difficult to tell if a directory exists.  This is ugly, but it works for writable directories.  http: will fall back on ftp for this"

	| probe success |
	success _ false.
	self isTypeFile ifTrue: [
		self entries size > 0 ifTrue: [^ true].
		probe _ self newFileNamed: 'withNoName23'. 
		probe ifNotNil: [
			probe close.
			probe directory deleteFileNamed: probe localName].
		^success _ probe notNil].
	[client := self openFTPClient.
	[client pwd]
		ensure: [self quit].
		success := true]
		on: Error
		do: [:ex | ].
	^success! !

!ServerDirectory methodsFor: 'file directory' stamp: 'tk 11/20/1998 12:28'!
fileAndDirectoryNames
	"FileDirectory default fileAndDirectoryNames"

	^ self entries collect: [:entry | entry first]
! !

!ServerDirectory methodsFor: 'file directory' stamp: 'RAA 7/4/2000 10:31'!
fileNamed: fullName
	"Create a RemoteFileStream for writing.  If the file exists, do not complain.  fullName is directory path, and does include name of the server.  Or it can just be a fileName.  Only write the data upon close."

	| file remoteStrm |
	file _ self asServerFileNamed: fullName.
	file readWrite.
	file isTypeFile ifTrue: [
		^ FileStream fileNamed: (file fileNameRelativeTo: self)
	].

	remoteStrm _ RemoteFileStream on: (String new: 2000).
	remoteStrm remoteFile: file.
	^ remoteStrm	"no actual writing till close"
! !

!ServerDirectory methodsFor: 'file directory' stamp: 'hg 2/8/2002 00:04'!
fileNames
	"Return a collection of names for the files (but not directories) in this directory."
	"(ServerDirectory serverNamed: 'UIUCArchive') fileNames"

	^ self entries select: [:entry | (entry at: 4) not]
		thenCollect: [:entry | entry first]
! !

!ServerDirectory methodsFor: 'file directory' stamp: 'hg 2/8/2002 17:39'!
fullNameFor: aFileName
	"Convention: 
	If it is an absolute path, directory stored with a leading slash, and url has no user@.
	If relative path, directory stored with no leading slash, and url begins user@.
	Should we include ftp:// on the front?"

	urlObject ifNotNil: [^ urlObject pathString, aFileName].
	(aFileName includes: self pathNameDelimiter)
		ifTrue: [^ aFileName].
	self isTypeHTTP ifTrue: [
		^ self downloadUrl, aFileName].
	directory isEmpty ifTrue: [^ server, 
		self pathNameDelimiter asString, aFileName].
	^ (directory first == $/ ifTrue: [''] ifFalse: [user,'@']), 
		server, self slashDirectory, 
		self pathNameDelimiter asString, aFileName! !

!ServerDirectory methodsFor: 'file directory' stamp: 'RAA 6/23/2000 09:47'!
getOnly: nnn from: fileNameOnServer
	| file ff resp |
	"Use FTP to just capture the first nnn characters of the file.  Break the connection after that.  Goes faster for long files.  Return the contents, not a stream."

	self isTypeFile ifTrue: [
		file _ self as: ServerFile.
		file fileName: fileNameOnServer.
		ff _ FileStream oldFileOrNoneNamed: (file fileNameRelativeTo: self).
		^ ff next: nnn].
	self isTypeHTTP ifTrue: [
		resp _ HTTPSocket httpGet: (self fullNameFor: fileNameOnServer) 
				accept: 'application/octet-stream'.
			"For now, get the whole file.  This branch not used often."
		^ resp truncateTo: nnn].
	
	^ self getOnlyBuffer: (String new: nnn) from: fileNameOnServer! !

!ServerDirectory methodsFor: 'file directory' stamp: 'tk 11/20/1998 12:28'!
includesKey: localName
	"Answer true if this directory includes a file or directory of the given name. Note that the name should be a local file name, in contrast with fileExists:, which takes either local or full-qualified file names."

	^ self fileAndDirectoryNames includes: localName
! !

!ServerDirectory methodsFor: 'file directory' stamp: 'hg 9/29/2001 15:35'!
localName

	directory isEmpty ifTrue: [self error: 'no directory'].
	^self localNameFor: directory! !

!ServerDirectory methodsFor: 'file directory' stamp: 'RAA 7/28/2000 13:46'!
localNameFor: fullName
	"Return the local part the given name."

	self
		splitName: fullName
		to: [:dirPath :localName | ^ localName]
! !

!ServerDirectory methodsFor: 'file directory' stamp: 'hg 9/29/2001 14:57'!
localPathExists: localPath

	^self directoryNames includes: localPath! !

!ServerDirectory methodsFor: 'file directory' stamp: 'mir 8/24/2001 12:01'!
matchingEntries: criteria
	"Ignore the filter criteria for now"
	^self entries! !

!ServerDirectory methodsFor: 'file directory' stamp: 'RAA 7/4/2000 10:32'!
newFileNamed: fullName
	"Create a RemoteFileStream.  If the file exists, and complain.  fullName is directory path, and does include name of the server.  Or it can just be a fileName.  Only write the data upon close."

	| file remoteStrm selection |

	file _ self asServerFileNamed: fullName.
	file readWrite.
	file isTypeFile ifTrue: [
		^ FileStream newFileNamed: (file fileNameRelativeTo: self)].
	file exists 
		ifTrue: [
			selection _ (PopUpMenu labels: 'overwrite that file
choose another name
cancel')
				startUpWithCaption: (file fullNameFor: file fileName) , '
already exists.']
		ifFalse: [selection _ 1].

	selection = 1 ifTrue:
		[remoteStrm _ RemoteFileStream on: (String new: 2000).
		remoteStrm remoteFile: file.
		remoteStrm dataIsValid.	"empty stream is the real contents!!"
		^ remoteStrm].	"no actual writing till close"
	selection = 2 ifTrue: [
		^ self newFileNamed:
			(FillInTheBlank request: 'Enter a new file name'
				initialAnswer: file fileName)].
	^ nil	"cancel"! !

!ServerDirectory methodsFor: 'file directory' stamp: 'RAA 7/4/2000 10:10'!
oldFileNamed: aName
	"If the file exists, answer a read-only RemoteFileStream on it.  aName is directory path, and does include name of the server.  Or it can just be a fileName.  For now, pre-read the file."

	| rFile |

	rFile _ self asServerFileNamed: aName.
	rFile readOnly.
	rFile isTypeFile ifTrue: [
		^ FileStream oldFileNamed: (rFile fileNameRelativeTo: self)].

	^self streamOnBeginningOf: rFile
! !

!ServerDirectory methodsFor: 'file directory' stamp: 'di 3/9/2001 01:25'!
oldFileOrNoneNamed: fullName
	"If the file exists, answer a read-only RemoteFileStream on it. If it doesn't, answer nil.  fullName is directory path, and does include name of the server.  Or just a simple fileName.  Do prefetch the data."
 
	| file |
	^ Cursor wait showWhile:
		[file _ self asServerFileNamed: fullName.
		file readOnly.
		"file exists ifFalse: [^ nil]."		"on the server"
		file isTypeFile
			ifTrue: [FileStream oldFileOrNoneNamed: (file fileNameRelativeTo: self)]
			ifFalse: [self streamOnBeginningOf: file]]! !

!ServerDirectory methodsFor: 'file directory' stamp: 'tk 9/19/1998 18:59'!
on: fullName
	"Answer another ServerDirectory on the partial path name.  fullName is directory path, and does include the name of the server."

	| new |
	new _ self copy.
	new fullPath: fullName.		"sets server, directory(path)"
	^ new! !

!ServerDirectory methodsFor: 'file directory' stamp: 'tk 1/14/1999 20:54'!
pathName
	"Path name as used in reading the file.  with slashes for ftp, with local file delimiter (:) for a file: url"

	urlObject ifNotNil: [^ urlObject pathForFile].
	directory size = 0 ifTrue: [^ server].
	^ (directory at: 1) = self pathNameDelimiter
		ifTrue: [server, directory]
		ifFalse: [user, '@', server, self pathNameDelimiter asString, directory]! !

!ServerDirectory methodsFor: 'file directory' stamp: 'tk 9/3/1998 12:34'!
pathNameDelimiter
	"the separator that is used in URLs"

	^ $/! !

!ServerDirectory methodsFor: 'file directory' stamp: 'tk 9/8/1998 12:12'!
pathParts
	"Return the path from the root of the file system to this directory as an array of directory names.  On a remote server."

	urlObject ifNotNil: [^ (urlObject path copy) removeLast; yourself].
	^ (OrderedCollection with: server) addAll: 
		(directory findTokens: self pathNameDelimiter asString);
			yourself.
! !

!ServerDirectory methodsFor: 'file directory' stamp: 'RAA 7/4/2000 10:08'!
readOnlyFileNamed: aName
	"If the file exists, answer a read-only RemoteFileStream on it.  aName is directory path, and does include name of the server.  Or it can just be a fileName.  For now, pre-read the file."

	| rFile |

	rFile _ self asServerFileNamed: aName.
	rFile readOnly.
	rFile isTypeFile ifTrue: [
		^ FileStream oldFileNamed: (rFile fileNameRelativeTo: self)].

	^self streamOnBeginningOf: rFile! !

!ServerDirectory methodsFor: 'file directory' stamp: 'mir 12/8/2003 14:17'!
rename: fullName toBe: newName
	"Rename a remote file.  fullName is just be a fileName, or can be directory path that includes name of the server.  newName is just a fileName"
	| file |

	file _ self asServerFileNamed: fullName.
	file isTypeFile ifTrue: [
		(FileDirectory forFileName: (file fileNameRelativeTo: self)) 
			rename: file fileName toBe: newName
	].
	
	client := self openFTPClient.
	[client renameFileNamed: fullName to: newName]
		ensure: [self quit].
	! !

!ServerDirectory methodsFor: 'file directory' stamp: 'RAA 6/23/2000 09:45'!
serverDelimiter
	"the separator that is used in the place where the file actually is.  ftp server or local disk."

	^ self isTypeFile 
		ifTrue: [FileDirectory default pathNameDelimiter]
		ifFalse: [$/]	"for ftp, http"! !

!ServerDirectory methodsFor: 'file directory' stamp: 'RAA 7/28/2000 13:46'!
splitName: fullName to: pathAndNameBlock
	"Take the file name and convert it to the path name of a directory and a local file name within that directory. FileName must be of the form: <dirPath><delimiter><localName>, where <dirPath><delimiter> is optional. The <dirPath> part may contain delimiters."

	| delimiter i dirName localName |
	delimiter _ self pathNameDelimiter.
	(i _ fullName findLast: [:c | c = delimiter]) = 0
		ifTrue:
			[dirName _ String new.
			localName _ fullName]
		ifFalse:
			[dirName _ fullName copyFrom: 1 to: (i - 1 max: 1).
			localName _ fullName copyFrom: i + 1 to: fullName size].

	^ pathAndNameBlock value: dirName value: localName! !

!ServerDirectory methodsFor: 'file directory' stamp: 'RAA 7/4/2000 10:03'!
streamOnBeginningOf: serverFile

	| remoteStrm |
	remoteStrm _ RemoteFileStream on: (String new: 2000).
	remoteStrm remoteFile: serverFile.
	serverFile getFileNamed: serverFile fileName into: remoteStrm.	"prefetch data"
	^ remoteStrm! !

!ServerDirectory methodsFor: 'multi-action sessions' stamp: 'mir 11/19/2002 17:51'!
reset
	! !

!ServerDirectory methodsFor: 'multi-action sessions' stamp: 'mir 12/8/2003 12:54'!
sleep
	"If still connected, break the connection"

	self quitClient.
	self keepAlive: false! !

!ServerDirectory methodsFor: 'multi-action sessions' stamp: 'mir 12/8/2003 12:55'!
wakeUp
	"Start a multi-action session: Open for FTP and keep the connection open"

	self isTypeFTP
		ifTrue: [client := self openFTPClient].
	self keepAlive: true
! !

!ServerDirectory methodsFor: 'server groups' stamp: 'mir 6/26/2001 11:56'!
closeGroup
	"Close connection with all servers in the group."

	self serversInGroup do: [:aDir | aDir quit].
! !

!ServerDirectory methodsFor: 'server groups' stamp: 'mir 6/26/2001 12:25'!
convertGroupName
	group
		ifNotNil: [self groupName: self groupName]! !

!ServerDirectory methodsFor: 'server groups' stamp: 'mir 6/26/2001 11:59'!
groupName

	^group
		ifNil: [self moniker]
		ifNotNil: [
			(group isKindOf: String)
				ifTrue: [group]
				ifFalse: [group key]]! !

!ServerDirectory methodsFor: 'server groups' stamp: 'mir 6/26/2001 12:13'!
groupName: groupName
	group _ groupName! !

!ServerDirectory methodsFor: 'server groups' stamp: 'mir 6/26/2001 11:57'!
openGroup
	"Open all servers in the group.  Don't forget to close later."

	self serversInGroup do: [:aDir | aDir wakeUp].
! !

!ServerDirectory methodsFor: 'server groups' stamp: 'mir 6/26/2001 11:56'!
serversInGroup
	^self groupName
		ifNil: [Array with: self]
		ifNotNil: [self class serversInGroupNamed: self groupName]! !

!ServerDirectory methodsFor: 'initialize' stamp: 'tk 11/26/1998 09:50'!
fromUser
	"Ask the user for all data on a new server.  Save it in a named server."  ! !

!ServerDirectory methodsFor: 'squeaklets' stamp: 'RAA 2/2/2001 08:29'!
directoryWrapperClass

	^FileDirectoryWrapper! !

!ServerDirectory methodsFor: 'squeaklets' stamp: 'tk 2/20/2000 18:34'!
moveAllButYoungest: young in: versions to: repository
	| all fName aVers bVers |
	"Specialized to files with names of the form 'aName_vvv.ext'.  Where vvv is a mime-encoded base 64 version number.  Versions is an array of file names tokenized into three parts (aName vvv ext).  Move the files by renaming them on the server."

	versions size <= young ifTrue: [^ self].
	all _ SortedCollection sortBlock: [:aa :bb | 
		aVers _ Base64MimeConverter decodeInteger: aa second unescapePercents.
		bVers _ Base64MimeConverter decodeInteger: bb second unescapePercents.
		aVers < bVers].
	all addAll: versions.
	young timesRepeat: [all removeLast].	"ones we keep"
	all do: [:vv |
		fName _ vv first, '_', vv second, '.', vv third.
		repository rename: self fullName,fName toBe: fName].
! !

!ServerDirectory methodsFor: 'squeaklets' stamp: 'mir 12/8/2003 12:35'!
upLoadProject: projectName members: archiveMembers retry: aBool
	| dir okay m dirName idx |
	m _ archiveMembers detect:[:any| any fileName includes: $/] ifNone:[nil].
	m == nil ifFalse:[
		dirName _ m fileName copyUpTo: $/.
		self createDirectory: dirName.
		dir _ self directoryNamed: dirName].
	archiveMembers do:[:entry|
		ProgressNotification signal: '4:uploadingFile' extra:'(uploading ', entry fileName,'...)'.
		idx _ entry fileName indexOf: $/.
		okay _ (idx > 0
			ifTrue:[
				dir putFile: entry contentStream 
					named: (entry fileName copyFrom: idx+1 to: entry fileName size) 
					retry: aBool]
			ifFalse:[
				self putFile: entry contentStream
					named: entry fileName
					retry: aBool]).
		(okay == false
			or: [okay isString])
			ifTrue: [
				self inform: 'Upload for ' , entry fileName printString , ' did not succeed (', okay , ').'.
				^false].
	].
	ProgressNotification signal: '4:uploadingFile' extra:''.
	^true! !

!ServerDirectory methodsFor: 'squeaklets' stamp: 'ar 3/2/2001 19:08'!
upLoadProject: projectFile named: fileNameOnServer resourceUrl: resUrl retry: aBool
	"Upload the given project file. If it's an archive, upload only the files that are local to the project."
	| archive members upload prefix |
	self isTypeFile ifTrue:[
 		^(FileDirectory on: urlObject pathForDirectory)
			upLoadProject: projectFile named: fileNameOnServer resourceUrl: resUrl retry: aBool].
	projectFile isZipArchive
		ifFalse:[^self putFile: projectFile named: fileNameOnServer retry: aBool].
	projectFile binary.
	archive _ ZipArchive new readFrom: projectFile.
	resUrl last = $/ 
		ifTrue:[prefix _ resUrl copyFrom: 1 to: resUrl size-1] "remove last slash"
		ifFalse:[prefix _ resUrl].
	prefix _ prefix copyFrom: 1 to: (prefix lastIndexOf: $/).
	members _ archive members select:[:entry|
		"figure out where it's coming from"
		upload _ false.
		(entry fileName indexOf: $:) = 0 ifTrue:[
			upload _ true. "one of the core files, e.g., project itself, resource map, meta info"
		] ifFalse:[
			(entry fileName asLowercase beginsWith: resUrl asLowercase) ifTrue:[
				upload _ true.
				entry fileName: (entry fileName copyFrom: prefix size+1 to: entry fileName size).
			].
		].
		upload].
	members _ members asArray sort:[:m1 :m2| m1 compressedSize < m2 compressedSize].
	^self upLoadProject: fileNameOnServer members: members retry: aBool.! !

!ServerDirectory methodsFor: 'squeaklets' stamp: 'RAA 10/12/2000 17:17'!
updateProjectInfoFor: aProject

	"only swiki servers for now"! !

!ServerDirectory methodsFor: 'squeaklets' stamp: 'dgd 12/23/2003 16:21'!
writeProject: aProject inFileNamed: fileNameString fromDirectory: localDirectory 
	"write aProject (a file version can be found in the file named fileNameString in localDirectory)"
	aProject
		writeFileNamed: fileNameString
		fromDirectory: localDirectory
		toServer: self! !

!ServerDirectory methodsFor: 'file-in/out' stamp: 'mir 6/29/2001 01:23'!
storeServerEntryOn: stream
	
	stream
		nextPutAll: 'name:'; tab; nextPutAll: (ServerDirectory nameForServer: self); cr;
		nextPutAll: 'directory:'; tab; nextPutAll: self directory; cr;
		nextPutAll: 'type:'; tab; nextPutAll: self typeForPrefs; cr;
		nextPutAll: 'server:'; tab; nextPutAll: self server; cr.
	group
		ifNotNil: [stream nextPutAll: 'group:'; tab; nextPutAll: self groupName; cr].
	self user
		ifNotNil: [stream nextPutAll: 'user:'; tab; nextPutAll: self user; cr].
	self passwordSequence
		ifNotNil: [stream nextPutAll: 'passwdseq:'; tab; nextPutAll: self passwordSequence asString; cr].
	self altUrl
		ifNotNil: [stream nextPutAll: 'url:'; tab; nextPutAll: self altUrl; cr].
	self loaderUrl
		ifNotNil: [stream nextPutAll: 'loaderUrl:'; tab; nextPutAll: self loaderUrl; cr].
	self acceptsUploads
		ifTrue: [stream nextPutAll: 'acceptsUploads:'; tab; nextPutAll: 'true'; cr]! !

!ServerDirectory methodsFor: 'updates' stamp: 'tk 1/7/2001 11:58'!
checkNames: list
	"Look at these names for update and see if they are OK"

list do: [:local |
	(local count: [:char | char == $.]) > 1 ifTrue: [
		self inform: 'File name ',local,'
may not have more than one period'.
	^ false].
	local size > 26 ifTrue: ["allows for 5 digit update numbers"
		self inform: 'File name ',local,'
is too long.  Please rename it.'.
	^ false].
	(local at: 1) isDigit ifTrue: [
		self inform: 'File name ',local,'
may not begin with a number'.
	^ false].
	(local findDelimiters: '%/* ' startingAt: 1) <= local size ifTrue: [
		self inform: 'File name ',local,'
may not contain % / * or space'.
	^ false]].
^ true
! !

!ServerDirectory methodsFor: 'updates' stamp: 'mir 12/8/2003 12:24'!
checkServersWithPrefix: prefix andParseListInto: listBlock
	"Check that all servers are up and have the latest Updates.list.
	Warn user when can't write to a server that can still be read.
	The contents of updates.list is parsed into {{vers. {fileNames*}}*},
	and returned via the listBlock."

	|  serverList updateLists listContents maxSize outOfDateServers |
	serverList _ self serversInGroup.
	serverList isEmpty
		ifTrue: [^Array new].

	updateLists := Dictionary new.
	serverList do: [:updateServer |
		[listContents := updateServer getFileNamed: prefix , 'updates.list'.
		updateLists at: updateServer put: listContents]
			on: Error
			do: [:ex | 
				(PopUpMenu labels: 'Cancel entire update' withCRs)
					startUpWithCaption: 'Server ', updateServer moniker,
					' is unavailable.\Please consider phoning the administator.\' withCRs, listContents.
				^Array new]].

	maxSize := (updateLists collect: [:each | each size]) max.
	outOfDateServers := updateLists keys select: [:updateServer |
		(updateLists at: updateServer) size < maxSize].

	outOfDateServers do: [:updateServer |
		(self outOfDate: updateServer) ifTrue: [^Array new]].

	listBlock value: (Utilities parseListContents: listContents).

	serverList removeAll: outOfDateServers.
	^serverList

! !

!ServerDirectory methodsFor: 'updates' stamp: 'di 10/3/2001 16:01'!
copyUpdatesNumbered: selectList toVersion: otherVersion
	"Into the section of updates.list corresponding to otherVersion,
	copy all the fileNames from this version matching the selectList."
"
		(ServerDirectory serverInGroupNamed: 'Disney Internal Updates*')
			copyUpdatesNumbered: #(4411 4412) to version: 'Squeak3.1beta'.
"
	| myServers updateStrm seq indexPrefix listContents version versIndex lastNum otherVersIndex additions outOfOrder |
	self openGroup.
	indexPrefix _ (self groupName includes: $*) 
		ifTrue: [(self groupName findTokens: ' ') first]	"special for internal updates"
		ifFalse: ['']. 	"normal"
	myServers _ self checkServersWithPrefix: indexPrefix
					andParseListInto: [:x | listContents _ x].
	myServers size = 0 ifTrue: [self closeGroup.  ^ self].

	version _ SystemVersion current version.
	versIndex _ (listContents collect: [:pair | pair first]) indexOf: version.
	versIndex = 0 ifTrue:
		[self inform: 'There is no section in updates.list for your version'.
		self closeGroup.  ^ nil].	"abort"
	otherVersIndex _ (listContents collect: [:pair | pair first]) indexOf: otherVersion.
	otherVersIndex = 0 ifTrue:
		[self inform: 'There is no section in updates.list for the target version'.
		self closeGroup.  ^ nil].	"abort"
	versIndex < listContents size ifTrue:
		[(self confirm: 'This system, ', version ,
				' is not the latest version.\OK to copy updates from that old version?' withCRs)
			ifFalse: [self closeGroup.  ^ nil]].	"abort"

	"Append all fileNames in my list that are not in the export list"
	additions _ OrderedCollection new.
	outOfOrder _ OrderedCollection new.
	lastNum _ (listContents at: otherVersIndex) last isEmpty
		ifTrue: [0]  "no checking if the current list is empty"
		ifFalse: [(listContents at: otherVersIndex) last last initialIntegerOrNil].
	(listContents at: versIndex) last do:
		[:fileName | seq _ fileName initialIntegerOrNil.
		(selectList includes: seq) ifTrue:
			[seq > lastNum
				ifTrue: [additions addLast: fileName]
				ifFalse: [outOfOrder addLast: seq]]].
	outOfOrder isEmpty ifFalse:
		[PopUpMenu notify: 'Updates numbered ' , outOfOrder asArray printString,
		' are out of order.\ The last update in ' withCRs,
		otherVersion, ' is ', lastNum printString,
		'.\No update will take place.' withCRs.
		self closeGroup.  ^ nil].	"abort"

	"Save old copy of updates.list on local disk"
	FileDirectory default deleteFileNamed: indexPrefix , 'updates.list.bk'.
	Utilities writeList: listContents toStream: (FileStream fileNamed: indexPrefix , 'updates.list.bk').

	"Write a new copy of updates.list on all servers..."
	listContents at: otherVersIndex put:
		{otherVersion. (listContents at: otherVersIndex) last , additions}.
	updateStrm _ ReadStream on:
		(String streamContents: [:s | Utilities writeList: listContents toStream: s]).
	myServers do:
		[:aServer |
		updateStrm reset.
		aServer putFile: updateStrm named: indexPrefix , 'updates.list' retry: true.
		Transcript show: 'Update succeeded on server ', aServer moniker; cr].
	self closeGroup.
		
	Transcript cr; show: 'Be sure to test your new update!!'; cr.
! !

!ServerDirectory methodsFor: 'updates' stamp: 'mir 12/8/2003 11:58'!
exportUpdatesExcept: skipList
	"Into the section of updates.list corresponding to this version,
	copy all the fileNames in the named updates.list for this group
	that are more recently numbered."
"
		(ServerDirectory serverInGroupNamed: 'Disney Internal Updates*')
			exportUpdatesExcept: #(3959).
"
	| myServers updateStrm response seq indexPrefix listContents version versIndex lastNum expContents expVersIndex additions |
	self openGroup.
	indexPrefix _ (self groupName includes: $*) 
		ifTrue: [(self groupName findTokens: ' ') first]	"special for internal updates"
		ifFalse: ['']. 	"normal"
	myServers _ self checkServersWithPrefix: indexPrefix
					andParseListInto: [:x | listContents _ x].
	myServers size = 0 ifTrue: [self closeGroup.  ^ self].

	version _ SystemVersion current version.
	versIndex _ (listContents collect: [:pair | pair first]) indexOf: version.
	versIndex = 0 ifTrue:
		[self inform: 'There is no section in updates.list for your version'.
		self closeGroup.  ^ nil].	"abort"
	versIndex < listContents size ifTrue:
		[response _ (PopUpMenu labels: 'Make update from an older version\Cancel update' withCRs)
			startUpWithCaption: 'This system, ', SystemVersion current version,
				' is not the latest version'.
		response = 1 ifFalse: [self closeGroup.  ^ nil]].	"abort"

	"Get the old export updates.list."
	expContents _  Utilities parseListContents: 
			(myServers first getFileNamed: 'updates.list').
	expVersIndex _ (expContents collect: [:pair | pair first]) indexOf: version.
	expVersIndex = 0 ifTrue:
		[self inform: 'There is no section in updates.list for your version'.
		self closeGroup.  ^ nil].	"abort"
	lastNum _ (expContents at: expVersIndex) last isEmpty
		ifTrue: [0]  "no checking if the current list is empty"
		ifFalse: [(expContents at: expVersIndex) last last initialIntegerOrNil].

	"Save old copy of updates.list on local disk"
	FileDirectory default deleteFileNamed: 'updates.list.bk'.
	Utilities writeList: expContents toStream: (FileStream fileNamed: 'updates.list.bk').

	"Append all fileNames in my list that are not in the export list"
	additions _ OrderedCollection new.
	(listContents at: versIndex) last do:
		[:fileName | seq _ fileName initialIntegerOrNil.
		(seq > lastNum and: [(skipList includes: seq) not]) ifTrue:
			[additions addLast: fileName]].
	expContents at: expVersIndex put:
		{version. (expContents at: expVersIndex) last , additions}.
	(self confirm: 'Do you really want to export ' , additions size printString , ' recent updates?')
		ifFalse: [self closeGroup.  ^ nil].	"abort"

	"Write a new copy of updates.list on all servers..."
	updateStrm _ ReadStream on:
		(String streamContents: [:s | Utilities writeList: expContents toStream: s]).
	myServers do:
		[:aServer |
		updateStrm reset.
		aServer putFile: updateStrm named: 'updates.list' retry: true.
		Transcript show: 'Update succeeded on server ', aServer moniker; cr].
	self closeGroup.
		
	Transcript cr; show: 'Be sure to test your new update!!'; cr.
! !

!ServerDirectory methodsFor: 'updates' stamp: 'tk 5/1/1998 15:03'!
outOfDate: aServer
	"Inform the user that this server does not have a current version of 'Updates.list'  Return true if the user does not want any updates to happen."

| response |
response _ (PopUpMenu labels: 'Install on others\Cancel entire update' withCRs)
		startUpWithCaption: 'The server ', aServer moniker, ' is not up to date.
Please store the missing updates maually.'.
^ response ~= 1! !

!ServerDirectory methodsFor: 'updates' stamp: 'di 10/3/2001 10:52'!
putUpdate: fileStrm
	"Put this file out as an Update on the servers of my group.  Each version of the system may have its own set of update files, or they may all share the same files.  'updates.list' holds the master list.  Each update is a fileIn whose name begins with a number.  See Utilities class readServerUpdatesThrough:saveLocally:updateImage:.
	When two sets of updates are stored on the same directory, one of them has a * in its 
serverUrls description.  When that is true, the first word of the description is put on
the front of 'updates.list', and that index file is used."

	| myServers updateStrm newName response localName seq indexPrefix listContents version versIndex lastNum stripped |
	localName _ fileStrm localName.
	fileStrm size = 0 ifTrue:
		[^ self inform: 'That file has zero bytes!!  May have a new name.'].
	(fileStrm contentsOfEntireFile includes: Character linefeed)
		ifTrue: [self notifyWithLabel:  'That file contains linefeeds.  Proceed if...
you know that this is okay (e.g. the file contains raw binary data).'].
	fileStrm reset.
	(self checkNames: {localName}) ifFalse: [^ nil].	"illegal characters"
	response _ (PopUpMenu labels: 'Install update\Cancel update' withCRs)
		startUpWithCaption: 'Do you really want to broadcast the file ', localName, 
			'\to every Squeak user who updates from ' withCRs, self groupName, '?'.
	response = 1 ifFalse: [^ nil].	"abort"

	self openGroup.
	indexPrefix _ (self groupName includes: $*) 
		ifTrue: [(self groupName findTokens: ' ') first]	"special for internal updates"
		ifFalse: ['']. 	"normal"
	myServers _ self checkServersWithPrefix: indexPrefix
					andParseListInto: [:x | listContents _ x].
	myServers size = 0 ifTrue: [self closeGroup.  ^ self].

	version _ SystemVersion current version.
	versIndex _ (listContents collect: [:pair | pair first]) indexOf: version.
	versIndex = 0 ifTrue:
		[self inform: 'There is no section in updates.list for your version'.
		self closeGroup.  ^ nil].	"abort"

	"A few affirmations..."
	versIndex < listContents size ifTrue:
		[(self confirm: 'This system, ', version ,
				' is not the latest version.\Make update for an older version?' withCRs)
			ifFalse: [self closeGroup.  ^ nil]].	"abort"
	(listContents at: versIndex) last isEmpty ifTrue:
		[(self confirm: 'Please confirm that you mean to issue the first update for ' ,
						version , '\(otherwise something is wrong).' withCRs)
			ifFalse: [self closeGroup.  ^ nil]].

	"We now determine next update number to be max of entire index"
	lastNum _ listContents inject: 0 into:
		[:max :pair | pair last isEmpty
					ifTrue: [max]
					ifFalse: [max max: pair last last initialIntegerOrNil]].

	"Save old copy of updates.list on local disk"
	FileDirectory default deleteFileNamed: indexPrefix , 'updates.list.bk'.
	Utilities writeList: listContents toStream: (FileStream fileNamed: indexPrefix , 'updates.list.bk').

	"append name to updates with new sequence number"
	seq _ (lastNum + 1) printString padded: #left to: 4 with: $0.
	"strip off any old seq number"
	stripped _ localName copyFrom: (localName  findFirst: [:c | c isDigit not]) to: localName size.
	newName _ seq , stripped.
	listContents at: versIndex put:
		{version. (listContents at: versIndex) last copyWith: newName}.

	"Write a new copy on all servers..."
	updateStrm _ ReadStream on:
		(String streamContents: [:s | Utilities writeList: listContents toStream: s]).
	myServers do:
		[:aServer |
		fileStrm reset.	"reopen"
		aServer putFile: fileStrm named: newName retry: true.
		updateStrm reset.
		aServer putFile: updateStrm named: indexPrefix , 'updates.list' retry: true.
		Transcript show: 'Update succeeded on server ', aServer moniker; cr].
	self closeGroup.
		
	Transcript cr; show: 'Be sure to test your new update!!'; cr.
	"rename the file locally (may fail)"
	fileStrm directory rename: localName toBe: newName.
! !

!ServerDirectory methodsFor: 'updates' stamp: 'di 11/14/2001 00:01'!
putUpdateMulti: list fromDirectory: updateDirectory 
	"Put these files out as an Update on the servers of my group.  List is an array of local file names with or without number prefixes.  Each version of the system has its own set of update files.  'updates.list' holds the master list.  Each update is a fileIn whose name begins with a number.  See Utilities class absorbUpdatesFromServer."

	| myServers updateStrm lastNum response newNames file numStr indexPrefix listContents version versIndex seq stripped |
	(self checkNames: (list collect: "Check the names without their numbers"
		[:each | each copyFrom: (each findFirst: [:c | c isDigit not]) to: each size]))
		ifFalse: [^ nil].
	response _ (PopUpMenu labels: 'Install update\Cancel update' withCRs)
		startUpWithCaption: 'Do you really want to broadcast ', list size printString, ' updates',
			'\to every Squeak user who updates from ' withCRs, self groupName, '?'.
	response = 1 ifFalse: [^ nil].	"abort"

	self openGroup.
	indexPrefix _ (self groupName includes: $*) 
		ifTrue: [(self groupName findTokens: ' ') first]	"special for internal updates"
		ifFalse: ['']. 	"normal"
	myServers _ self checkServersWithPrefix: indexPrefix
					andParseListInto: [:x | listContents _ x].
	myServers size = 0 ifTrue: [self closeGroup.  ^ self].

	version _ SystemVersion current version.
	versIndex _ (listContents collect: [:pair | pair first]) indexOf: version.
	versIndex = 0 ifTrue:
		[self inform: 'There is no section in updates.list for your version'.
		self closeGroup.  ^ nil].	"abort"
	lastNum _ (listContents at: versIndex) last last initialIntegerOrNil.
	versIndex < listContents size ifTrue:
		[response _ (PopUpMenu labels: 'Make update for an older version\Cancel update' withCRs)
			startUpWithCaption: 'This system, ', SystemVersion current version,
				' is not the latest version'.
		response = 1 ifFalse: [self closeGroup.  ^ nil].
		numStr _ FillInTheBlank 
			request: 'Please confirm or change the starting update number' 
			initialAnswer: (lastNum+1) printString.
		lastNum _ numStr asNumber - 1].	"abort"
	"Save old copy of updates.list on local disk"
	FileDirectory default deleteFileNamed: indexPrefix , 'updates.list.bk'.
	Utilities writeList: listContents toStream: (FileStream fileNamed: indexPrefix , 'updates.list.bk').

	"Append names to updates with new sequence numbers"
	newNames _ list with: (lastNum+1 to: lastNum+list size) collect:
		[:each :num | seq _ num printString padded: #left to: 4 with: $0.
		"strip off any old seq number"
		stripped _ each copyFrom: (each  findFirst: [:c | c isDigit not]) to: each size.
		seq , stripped].
	listContents at: versIndex put:
		{version. (listContents at: versIndex) second , newNames}.

	"Write a new copy on all servers..."
	updateStrm _ ReadStream on:
		(String streamContents: [:s | Utilities writeList: listContents toStream: s]).
	myServers do:
		[:aServer |
		list doWithIndex: [:local :ind |
			file _ updateDirectory oldFileNamed: local.
			aServer putFile: file named: (newNames at: ind) retry: true.
			file close].
		updateStrm reset.
		aServer putFile: updateStrm named: indexPrefix , 'updates.list' retry: true.
		Transcript show: 'Update succeeded on server ', aServer moniker; cr].
	self closeGroup.

	Transcript cr; show: 'Be sure to test your new update!!'; cr.
	"rename the file locally"
	list with: newNames do:
		[:local :newName | updateDirectory rename: local toBe: newName].
! !

!ServerDirectory methodsFor: 'updates' stamp: 'mir 6/26/2001 12:07'!
updateInstallVersion: newVersion
	"For each server group, ask whether we want to put the new version marker (eg 'Squeak2.3') at the end of the file.  Current version of Squeak must be the old one when this is done.
		ServerDirectory new updateInstallVersion: 'Squeak9.9test'
"
	| myServers updateStrm names choice indexPrefix listContents version versIndex |
	[names _ ServerDirectory groupNames asSortedArray.
	choice _ (SelectionMenu labelList: names selections: names) startUp.
	choice == nil]
		whileFalse:
		[indexPrefix _ (choice endsWith: '*') 
			ifTrue: [(choice findTokens: ' ') first]	"special for internal updates"
			ifFalse: ['']. 	"normal"
		myServers _ (ServerDirectory serverInGroupNamed: choice)
						checkServersWithPrefix: indexPrefix
						andParseListInto: [:x | listContents _ x].
		myServers size = 0 ifTrue: [^ self].

		version _ SystemVersion current version.
		versIndex _ (listContents collect: [:pair | pair first]) indexOf: version.
		versIndex = 0 ifTrue:
			[^ self inform: 'There is no section in updates.list for your version'].  "abort"

		"Append new version to updates following my version"
		listContents _ listContents copyReplaceFrom: versIndex+1 to: versIndex with: {{newVersion. {}}}.
		updateStrm _ ReadStream on:
			(String streamContents: [:s | Utilities writeList: listContents toStream: s]).

		myServers do:
			[:aServer | updateStrm reset.
			aServer putFile: updateStrm named: indexPrefix ,'updates.list'.
			Transcript cr; show: indexPrefix ,'updates.list written on server ', aServer moniker].
		self closeGroup]! !

!ServerDirectory methodsFor: 'school support' stamp: 'ar 9/5/2001 15:45'!
eToyUserList
	"Return a list of all known users for eToy login support"
	| urlString |
	eToyUserList ifNotNil:[^eToyUserList].
	urlString _ self eToyUserListUrl.
	urlString ifNil:[^nil].
	eToyUserList _ self class parseEToyUserListFrom: urlString.
	^eToyUserList! !

!ServerDirectory methodsFor: 'school support' stamp: 'ar 8/24/2001 14:31'!
eToyUserList: aCollectionOrNil
	"Set a list of all known users for eToy login support"
	eToyUserList _ aCollectionOrNil.! !

!ServerDirectory methodsFor: 'school support' stamp: 'ar 8/24/2001 14:29'!
eToyUserListUrl
	^eToyUserListUrl! !

!ServerDirectory methodsFor: 'school support' stamp: 'ar 8/24/2001 14:31'!
eToyUserListUrl: aString
	eToyUserListUrl _ aString.
	eToyUserList _ nil.! !

!ServerDirectory methodsFor: 'school support' stamp: 'ar 9/5/2001 16:05'!
eToyUserName: aString
	"Ignored here"! !

!ServerDirectory methodsFor: 'school support' stamp: 'ar 9/5/2001 16:12'!
hasEToyUserList
	^eToyUserListUrl notNil! !


!ServerDirectory class methodsFor: 'misc' stamp: 'tk 12/29/1998 22:46'!
defaultStemUrl
	"For writing on an FTP directory.  Users should insert their own server url here."
"ftp://jumbo.rd.wdi.disney.com/raid1/people/dani/Books/Grp/Grp"
"	ServerDirectory defaultStemUrl	"

| rand dir |
rand _ String new: 4.
1 to: rand size do: [:ii |
	rand at: ii put: ('bdfghklmnpqrstvwz' at: 17 atRandom)].
dir _ self serverNamed: 'DaniOnJumbo'.
^ 'ftp://', dir server, dir slashDirectory, '/BK', rand! !

!ServerDirectory class methodsFor: 'misc' stamp: 'tk 9/8/1998 11:57'!
newFrom: aSimilarObject
	"Must copy the urlObject, so they won't be shared"

	| inst |
	inst _ super newFrom: aSimilarObject.
	inst urlObject: aSimilarObject urlObject copy.
	^ inst! !

!ServerDirectory class methodsFor: 'misc' stamp: 'hg 9/21/2001 16:40'!
on: pathString

	^self new on: pathString! !

!ServerDirectory class methodsFor: 'misc' stamp: 'mir 4/13/2001 12:41'!
parseFTPEntry: ftpEntry
	| tokens longy dateInSeconds thisYear thisMonth |
	thisYear _ Date today year.
	thisMonth _ Date today monthIndex.
	tokens _ ftpEntry findTokens: ' '.
	tokens size = 8 ifTrue:
		[((tokens at: 6) size ~= 3 and: [(tokens at: 5) size = 3]) ifTrue:
			["Fix for case that group is blank (relies on month being 3 chars)"
			tokens _ tokens copyReplaceFrom: 4 to: 3 with: {'blank'}]].
	tokens size >= 9 ifFalse:[^nil].

	((tokens at: 6) size ~= 3 and: [(tokens at: 5) size = 3]) ifTrue:
		["Fix for case that group is blank (relies on month being 3 chars)"
		tokens _ tokens copyReplaceFrom: 4 to: 3 with: {'blank'}].

	tokens size > 9 ifTrue:
		[longy _ tokens at: 9.
		10 to: tokens size do: [:i | longy _ longy , ' ' , (tokens at: i)].
		tokens at: 9 put: longy].
	dateInSeconds _ self
		secondsForDay: (tokens at: 7) 
		month: (tokens at: 6) 
		yearOrTime: (tokens at: 8) 
		thisMonth: thisMonth 
		thisYear: thisYear.
	^DirectoryEntry name: (tokens at: 9)  "file name"
		creationTime: dateInSeconds "creation date"
		modificationTime: dateInSeconds "modification time"
		isDirectory: tokens first first = $d "is-a-directory flag"
		fileSize: tokens fifth asNumber "file size"
! !

!ServerDirectory class methodsFor: 'misc' stamp: 'mir 4/13/2001 12:44'!
secondsForDay: dayToken month: monthToken yearOrTime: ytToken 
thisMonth: thisMonth thisYear: thisYear

	| ftpDay ftpMonth pickAYear jDateToday trialJulianDate |

	ftpDay _ dayToken asNumber.
	ftpMonth _ Date indexOfMonth: monthToken.
	(ytToken includes: $:) ifFalse: [
		^(Date newDay: ftpDay month: ftpMonth year: ytToken asNumber) asSeconds
	].
	jDateToday _ Date today dayOfYear.
	trialJulianDate _ (Date newDay: ftpDay month: ftpMonth year: thisYear) dayOfYear.
	
	"Date has no year if within six months (do we need to check the day, too?)"

	"Well it appear to be pickier than that... it isn't just 6 months or 6 months and the day of the month, put perhaps the julian date AND the time as well. I don't know what the precise standard is, but this seems to produce better results"

	pickAYear _ (jDateToday - trialJulianDate) > 182 ifTrue: [
		thisYear + 1	"his clock could be ahead of ours??"
	] ifFalse: [
		pickAYear _ (trialJulianDate - jDateToday) > 182 ifTrue: [
			thisYear - 1
		] ifFalse: [
			thisYear
		].
	].
	^(Date newDay: ftpDay month: ftpMonth year: pickAYear) asSeconds +
		(Time readFrom: (ReadStream on: ytToken)) asSeconds

! !

!ServerDirectory class methodsFor: 'available servers' stamp: 'mir 5/24/2001 17:49'!
addLocalProjectDirectory: aFileDirectory
	self localProjectDirectories add: aFileDirectory
! !

!ServerDirectory class methodsFor: 'available servers' stamp: 'mir 6/26/2001 09:46'!
addServer: server named: nameString
	self servers at: nameString put: server! !

!ServerDirectory class methodsFor: 'available servers' stamp: 'mir 5/24/2001 17:48'!
localProjectDirectories
	LocalProjectDirectories ifNil: [LocalProjectDirectories _ OrderedCollection new].
	^LocalProjectDirectories! !

!ServerDirectory class methodsFor: 'available servers' stamp: 'mir 6/26/2001 09:45'!
nameForServer: aServer
	^self servers keyAtValue: aServer! !

!ServerDirectory class methodsFor: 'available servers' stamp: 'mir 11/14/2001 16:26'!
projectServers
	"ServerDirectory projectServers"

	| projectServers projectServer |
	projectServers _ OrderedCollection new.
	self serverNames do: [ :n | 
		projectServer _ ServerDirectory serverNamed: n.
		(projectServer isProjectSwiki and: [projectServer isSearchable])
			ifTrue: [projectServers add: projectServer]].
	^projectServers! !

!ServerDirectory class methodsFor: 'available servers' stamp: 'mir 6/26/2001 09:47'!
removeServerNamed: nameString
	self
		removeServerNamed: nameString
		ifAbsent: [self error: 'Server "' , nameString asString , '" not found']! !

!ServerDirectory class methodsFor: 'available servers' stamp: 'mir 6/26/2001 09:46'!
removeServerNamed: nameString ifAbsent: aBlock
	self servers removeKey: nameString ifAbsent: [aBlock value]! !

!ServerDirectory class methodsFor: 'available servers' stamp: 'ar 9/5/2001 16:11'!
resetLocalProjectDirectories
	LocalProjectDirectories _ nil.
	LocalEToyUserListUrls _ nil.
	LocalEToyBaseFolderSpecs _ nil.
! !

!ServerDirectory class methodsFor: 'available servers' stamp: 'mir 6/26/2001 09:45'!
resetServers
	Servers _ nil! !

!ServerDirectory class methodsFor: 'available servers' stamp: 'mir 6/26/2001 14:29'!
serverForURL: aURL
	| serversForURL server urlPath serverPath relPath |
	serversForURL _ self servers values select: [:each |
		(aURL beginsWith: each downloadUrl)
		or: [(aURL beginsWith: each realUrl)
		or: [aURL , '/' beginsWith: each downloadUrl]]].
	serversForURL isEmpty
		ifTrue: [^nil].
	server _ serversForURL first.
	urlPath _ aURL asUrl path.
	(urlPath isEmpty not
		and: [urlPath last isEmpty])
		ifTrue: [urlPath removeLast].
	serverPath _ server downloadUrl asUrl path.
	(serverPath isEmpty not
		and: [serverPath last isEmpty])
		ifTrue: [serverPath removeLast].
	urlPath size < serverPath size
		ifTrue: [^nil].
	relPath _ String new.
	serverPath size +1 to: urlPath size do: [:i | relPath _ relPath , '/' , (urlPath at: i)].
	^relPath isEmpty
		ifTrue: [server]
		ifFalse: [server directoryNamed: (relPath copyFrom: 2 to: relPath size)]! !

!ServerDirectory class methodsFor: 'available servers' stamp: 'mir 6/26/2001 14:06'!
serverNamed: nameString
	^self serverNamed: nameString ifAbsent: [self error: 'Server name not found']! !

!ServerDirectory class methodsFor: 'available servers' stamp: 'mir 6/26/2001 09:44'!
serverNamed: nameString ifAbsent: aBlock
	^self servers at: nameString asString ifAbsent: [aBlock value]! !

!ServerDirectory class methodsFor: 'available servers' stamp: 'mir 6/26/2001 09:48'!
serverNames
	^self servers keys asSortedArray! !

!ServerDirectory class methodsFor: 'available servers' stamp: 'mir 6/26/2001 09:45'!
servers
	Servers ifNil: [Servers _ Dictionary new].
	^Servers! !

!ServerDirectory class methodsFor: 'server groups' stamp: 'mir 6/26/2001 12:26'!
convertGroupNames
	"ServerDirectory convertGroupNames"
	self servers do: [:each | each convertGroupName]! !

!ServerDirectory class methodsFor: 'server groups' stamp: 'mir 6/26/2001 12:11'!
groupNames
	"Return the names of all registered groups of servers, including individual servers not in any group."
	"ServerDirectory groupNames"
	| names |
	names _ Set new.
	self servers do: [:server |
		names add: server groupName].
	^names asSortedArray
! !

!ServerDirectory class methodsFor: 'server groups' stamp: 'edc 6/30/2004 09:52'!
localSqueakBooksDirectory
	| fd |
	LocalSqueakBooksDirectory ifNil: [fd _ FileDirectory default. 
(fd directoryExists:  'SqueakBooks') ifFalse:[fd createDirectory: 'SqueakBooks'].
		
		LocalSqueakBooksDirectory _ FileDirectory default pathName  , FileDirectory slash ,  'SqueakBooks' ].
	^LocalSqueakBooksDirectory! !

!ServerDirectory class methodsFor: 'server groups' stamp: 'mir 6/26/2001 12:06'!
serverInGroupNamed: groupName
	"Return the first (available) server in the group of this name."

	| servers |
	servers _ self serversInGroupNamed: groupName.
	servers isEmpty
		ifTrue: [self error: 'No server found in group "' , groupName asString , '".'].
	^servers first! !

!ServerDirectory class methodsFor: 'server groups' stamp: 'mir 6/26/2001 11:55'!
serversInGroupNamed: nameString
	"Return the servers in the group of this name."
	"ServerDirectory serversInGroupNamed: 'Squeak Public Updates' "

	^self servers values select: [:server |
		nameString = server groupName].
! !

!ServerDirectory class methodsFor: 'server prefs' stamp: 'sd 9/30/2003 13:58'!
determineLocalServerDirectory: directoryName
	"This is part of a workaround for Mac file name oddities regarding relative file names.
	The real fix should be in fullNameFor: but that seems to break other parts of the system."

	| dirName |
	dirName _ directoryName.
	(SmalltalkImage current platformName = 'Mac OS'
		and: [directoryName beginsWith: ':'])
			ifTrue: [
				dirName _ (FileDirectory default pathName endsWith: directoryName)
					ifTrue: [FileDirectory default pathName]
					ifFalse: [(FileDirectory default pathName , directoryName) replaceAll: '::' with: ':']].
	^FileDirectory default directoryNamed: dirName! !

!ServerDirectory class methodsFor: 'server prefs' stamp: 'mir 5/30/2001 15:28'!
fetchExternalSettingsIn: aDirectory
	"Scan for server configuration files"
	"ServerDirectory fetchExternalSettingsIn: (FileDirectory default directoryNamed: 'prefs')"

	| serverConfDir stream |
	(aDirectory directoryExists: self serverConfDirectoryName)
		ifFalse: [^self].
	self resetLocalProjectDirectories.
	serverConfDir _ aDirectory directoryNamed: self serverConfDirectoryName.
	serverConfDir fileNames do: [:fileName |
		stream _ serverConfDir readOnlyFileNamed: fileName.
		stream
			ifNotNil: [
				[self parseServerEntryFrom: stream] ifError: [:err :rcvr | ].
				stream close]]! !

!ServerDirectory class methodsFor: 'server prefs' stamp: 'mir 8/23/2002 14:22'!
parseServerEntryFrom: stream
	
	| server type directory entries serverName |

	entries _ ExternalSettings parseServerEntryArgsFrom: stream.

	serverName _ entries at: 'name' ifAbsent: [^nil].
	directory _ entries at: 'directory' ifAbsent: [^nil].
	type _ entries at: 'type' ifAbsent: [^nil].
	type = 'file'
		ifTrue: [
			server _ self determineLocalServerDirectory: directory.
			entries at: 'userListUrl' ifPresent:[:value | server eToyUserListUrl: value].
			entries at: 'baseFolderSpec' ifPresent:[:value | server eToyBaseFolderSpec: value].
			^self addLocalProjectDirectory: server].
	type = 'bss'
		ifTrue: [server _ SuperSwikiServer new type: #http].
	type = 'http'
		ifTrue: [server _ HTTPServerDirectory new type: #ftp].
	type = 'ftp'
		ifTrue: [server _ ServerDirectory new type: #ftp].

	server directory: directory.
	entries at: 'server' ifPresent: [:value | server server: value].
	entries at: 'user' ifPresent: [:value | server user: value].
	entries at: 'group' ifPresent: [:value | server groupName: value].
	entries at: 'passwdseq' ifPresent: [:value | server passwordSequence: value asNumber].
	entries at: 'url' ifPresent: [:value | server altUrl: value].
	entries at: 'loaderUrl' ifPresent: [:value | server loaderUrl: value].
	entries at: 'acceptsUploads' ifPresent: [:value | server acceptsUploads: value asLowercase = 'true'].
	entries at: 'userListUrl' ifPresent:[:value | server eToyUserListUrl: value].
	ServerDirectory addServer: server named: serverName.
! !

!ServerDirectory class methodsFor: 'server prefs' stamp: 'mir 8/22/2001 17:01'!
releaseExternalSettings
	"Release for server configurations"
	"ServerDirectory releaseExternalSettings"

	Preferences externalServerDefsOnly
		ifTrue: [
			self resetLocalProjectDirectories.
			Servers _ Dictionary new]! !

!ServerDirectory class methodsFor: 'server prefs' stamp: 'mir 5/24/2001 17:08'!
serverConfDirectoryName
	^'knownServers'! !

!ServerDirectory class methodsFor: 'server prefs' stamp: 'mir 6/26/2001 09:49'!
storeCurrentServersIn: aDirectory

	| file |
	self servers do: [:each |
		file _ aDirectory fileNamed: (ServerDirectory nameForServer: each).
		each storeServerEntryOn: file.
		file close].
	self localProjectDirectories do: [:each |
		file _ aDirectory fileNamed: each localName.
		each storeServerEntryOn: file.
		file close].
! !

!ServerDirectory class methodsFor: 'server prefs' stamp: 'hg 9/29/2001 14:35'!
transferServerDefinitionsToExternal
	"ServerDirectory transferServerDefinitionsToExternal"

	| serverDir |
	serverDir _ ExternalSettings preferenceDirectory directoryNamed: self serverConfDirectoryName.
	serverDir assureExistence.
	ServerDirectory storeCurrentServersIn: serverDir! !

!ServerDirectory class methodsFor: 'class initialization' stamp: 'mir 6/25/2001 18:46'!
initialize
	"ServerDirectory initialize"
	"ServerDirectory resetLocalProjectDirectories.
	Servers _ Dictionary new."

	ExternalSettings registerClient: self! !

!ServerDirectory class methodsFor: 'school support' stamp: 'ar 9/5/2001 16:10'!
eToyBaseFolderSpecForFileDirectory: aFileDirectory
	^self localEToyBaseFolderSpecs at: aFileDirectory ifAbsent:[nil]! !

!ServerDirectory class methodsFor: 'school support' stamp: 'ar 9/5/2001 16:30'!
eToyBaseFolderSpecForFileDirectory: aFileDirectory put: aString
	^self localEToyBaseFolderSpecs at: aFileDirectory put: aString! !

!ServerDirectory class methodsFor: 'school support' stamp: 'ar 9/5/2001 16:38'!
eToyUserListForFileDirectory: aFileDirectory
	| urlString |
	urlString _ self eToyUserListUrlForFileDirectory: aFileDirectory.
	urlString ifNil:[^nil].
	^self parseEToyUserListFrom: urlString! !

!ServerDirectory class methodsFor: 'school support' stamp: 'ar 9/5/2001 15:46'!
eToyUserListUrlForFileDirectory: aFileDirectory
	^self localEToyUserListUrls at: aFileDirectory ifAbsent:[nil]! !

!ServerDirectory class methodsFor: 'school support' stamp: 'ar 9/5/2001 15:48'!
eToyUserListUrlForFileDirectory: aFileDirectory put: urlString
	^self localEToyUserListUrls at: aFileDirectory put: urlString! !

!ServerDirectory class methodsFor: 'school support' stamp: 'ar 9/5/2001 16:11'!
localEToyBaseFolderSpecs
	^LocalEToyBaseFolderSpecs ifNil:[LocalEToyBaseFolderSpecs _ IdentityDictionary new]! !

!ServerDirectory class methodsFor: 'school support' stamp: 'ar 9/5/2001 15:47'!
localEToyUserListUrls
	^LocalEToyUserListUrls ifNil:[LocalEToyUserListUrls _ IdentityDictionary new].! !

!ServerDirectory class methodsFor: 'school support' stamp: 'ar 9/5/2001 16:34'!
parseEToyUserListFrom: urlString
	| url userString userList |
	urlString ifNil:[^nil].
	url _ urlString asUrl.
	["Note: We need to prevent going through the plugin API 
	when retrieving a local (file) URL, since the plugin API
	(correctly) rejects file:// downloads."
		Cursor wait showWhile:[
			(url hasRemoteContents) ifTrue:[
				"Go through the browser (if present)"
				userString _ (HTTPClient httpGet: url toText) contents.
			] ifFalse:[
				"Go grab it directly"
				userString _ url retrieveContents contents.
			].
		].
	] on: Error do:[:ex| userString _ nil. ex return].
	userString ifNil:[^nil].
	"Get rid of any line ending problems"
	userString _ userString copyReplaceAll: String crlf with: String cr.
	userString _ userString copyReplaceAll: String lf with: String cr.
	userList _ (userString findTokens: Character cr) collect:[:each| each withBlanksTrimmed].
	userList _ userList reject:[:any| any isEmpty].
	(userList first = '##user list##') ifFalse:[^nil].
	userList _ userList copyFrom: 2 to: userList size.
	^userList! !

!ServerDirectory class methodsFor: 'school support' stamp: 'mir 9/5/2001 18:39'!
projectDefaultDirectory
	^Preferences eToyLoginEnabled
		ifTrue: [
			(ServerDirectory localProjectDirectories, ServerDirectory servers values)
						detect:[:any| any hasEToyUserList]
						ifNone:[FileDirectory default]]
		ifFalse: [FileDirectory default]! !

ServerDirectory initialize!
MiStack removeSelector: #cardFromICabZipFile:!
